/*      */ package com.google.code.yanf4j.buffer;
/*      */ 
/*      */ import java.io.InputStream;
/*      */ import java.io.OutputStream;
/*      */ import java.nio.ByteBuffer;
/*      */ import java.nio.ByteOrder;
/*      */ import java.nio.CharBuffer;
/*      */ import java.nio.DoubleBuffer;
/*      */ import java.nio.FloatBuffer;
/*      */ import java.nio.IntBuffer;
/*      */ import java.nio.LongBuffer;
/*      */ import java.nio.ShortBuffer;
/*      */ import java.nio.charset.CharacterCodingException;
/*      */ import java.nio.charset.CharsetDecoder;
/*      */ import java.nio.charset.CharsetEncoder;
/*      */ import java.util.EnumSet;
/*      */ import java.util.Set;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class IoBufferWrapper
/*      */   extends IoBuffer
/*      */ {
/*      */   private final IoBuffer buf;
/*      */   
/*      */   protected IoBufferWrapper(IoBuffer buf)
/*      */   {
/*   66 */     if (buf == null) {
/*   67 */       throw new NullPointerException("buf");
/*      */     }
/*   69 */     this.buf = buf;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public IoBuffer getParentBuffer()
/*      */   {
/*   77 */     return this.buf;
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean isDirect()
/*      */   {
/*   83 */     return this.buf.isDirect();
/*      */   }
/*      */   
/*      */ 
/*      */   public ByteBuffer buf()
/*      */   {
/*   89 */     return this.buf.buf();
/*      */   }
/*      */   
/*      */ 
/*      */   public int capacity()
/*      */   {
/*   95 */     return this.buf.capacity();
/*      */   }
/*      */   
/*      */ 
/*      */   public int position()
/*      */   {
/*  101 */     return this.buf.position();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer position(int newPosition)
/*      */   {
/*  107 */     this.buf.position(newPosition);
/*  108 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public int limit()
/*      */   {
/*  114 */     return this.buf.limit();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer limit(int newLimit)
/*      */   {
/*  120 */     this.buf.limit(newLimit);
/*  121 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer mark()
/*      */   {
/*  127 */     this.buf.mark();
/*  128 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer reset()
/*      */   {
/*  134 */     this.buf.reset();
/*  135 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer clear()
/*      */   {
/*  141 */     this.buf.clear();
/*  142 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer sweep()
/*      */   {
/*  148 */     this.buf.sweep();
/*  149 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer sweep(byte value)
/*      */   {
/*  155 */     this.buf.sweep(value);
/*  156 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer flip()
/*      */   {
/*  162 */     this.buf.flip();
/*  163 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer rewind()
/*      */   {
/*  169 */     this.buf.rewind();
/*  170 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public int remaining()
/*      */   {
/*  176 */     return this.buf.remaining();
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean hasRemaining()
/*      */   {
/*  182 */     return this.buf.hasRemaining();
/*      */   }
/*      */   
/*      */ 
/*      */   public byte get()
/*      */   {
/*  188 */     return this.buf.get();
/*      */   }
/*      */   
/*      */ 
/*      */   public short getUnsigned()
/*      */   {
/*  194 */     return this.buf.getUnsigned();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer put(byte b)
/*      */   {
/*  200 */     this.buf.put(b);
/*  201 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public byte get(int index)
/*      */   {
/*  207 */     return this.buf.get(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public short getUnsigned(int index)
/*      */   {
/*  213 */     return this.buf.getUnsigned(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer put(int index, byte b)
/*      */   {
/*  219 */     this.buf.put(index, b);
/*  220 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer get(byte[] dst, int offset, int length)
/*      */   {
/*  226 */     this.buf.get(dst, offset, length);
/*  227 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer getSlice(int index, int length)
/*      */   {
/*  233 */     return this.buf.getSlice(index, length);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer getSlice(int length)
/*      */   {
/*  239 */     return this.buf.getSlice(length);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer get(byte[] dst)
/*      */   {
/*  245 */     this.buf.get(dst);
/*  246 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer put(IoBuffer src)
/*      */   {
/*  252 */     this.buf.put(src);
/*  253 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer put(ByteBuffer src)
/*      */   {
/*  259 */     this.buf.put(src);
/*  260 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer put(byte[] src, int offset, int length)
/*      */   {
/*  266 */     this.buf.put(src, offset, length);
/*  267 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer put(byte[] src)
/*      */   {
/*  273 */     this.buf.put(src);
/*  274 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer compact()
/*      */   {
/*  280 */     this.buf.compact();
/*  281 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public String toString()
/*      */   {
/*  287 */     return this.buf.toString();
/*      */   }
/*      */   
/*      */ 
/*      */   public int hashCode()
/*      */   {
/*  293 */     return this.buf.hashCode();
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean equals(Object ob)
/*      */   {
/*  299 */     return this.buf.equals(ob);
/*      */   }
/*      */   
/*      */   public int compareTo(IoBuffer that)
/*      */   {
/*  304 */     return this.buf.compareTo(that);
/*      */   }
/*      */   
/*      */ 
/*      */   public ByteOrder order()
/*      */   {
/*  310 */     return this.buf.order();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer order(ByteOrder bo)
/*      */   {
/*  316 */     this.buf.order(bo);
/*  317 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public char getChar()
/*      */   {
/*  323 */     return this.buf.getChar();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putChar(char value)
/*      */   {
/*  329 */     this.buf.putChar(value);
/*  330 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public char getChar(int index)
/*      */   {
/*  336 */     return this.buf.getChar(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putChar(int index, char value)
/*      */   {
/*  342 */     this.buf.putChar(index, value);
/*  343 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public CharBuffer asCharBuffer()
/*      */   {
/*  349 */     return this.buf.asCharBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public short getShort()
/*      */   {
/*  355 */     return this.buf.getShort();
/*      */   }
/*      */   
/*      */ 
/*      */   public int getUnsignedShort()
/*      */   {
/*  361 */     return this.buf.getUnsignedShort();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putShort(short value)
/*      */   {
/*  367 */     this.buf.putShort(value);
/*  368 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public short getShort(int index)
/*      */   {
/*  374 */     return this.buf.getShort(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public int getUnsignedShort(int index)
/*      */   {
/*  380 */     return this.buf.getUnsignedShort(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putShort(int index, short value)
/*      */   {
/*  386 */     this.buf.putShort(index, value);
/*  387 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public ShortBuffer asShortBuffer()
/*      */   {
/*  393 */     return this.buf.asShortBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public int getInt()
/*      */   {
/*  399 */     return this.buf.getInt();
/*      */   }
/*      */   
/*      */ 
/*      */   public long getUnsignedInt()
/*      */   {
/*  405 */     return this.buf.getUnsignedInt();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putInt(int value)
/*      */   {
/*  411 */     this.buf.putInt(value);
/*  412 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public int getInt(int index)
/*      */   {
/*  418 */     return this.buf.getInt(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public long getUnsignedInt(int index)
/*      */   {
/*  424 */     return this.buf.getUnsignedInt(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putInt(int index, int value)
/*      */   {
/*  430 */     this.buf.putInt(index, value);
/*  431 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IntBuffer asIntBuffer()
/*      */   {
/*  437 */     return this.buf.asIntBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public long getLong()
/*      */   {
/*  443 */     return this.buf.getLong();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putLong(long value)
/*      */   {
/*  449 */     this.buf.putLong(value);
/*  450 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public long getLong(int index)
/*      */   {
/*  456 */     return this.buf.getLong(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putLong(int index, long value)
/*      */   {
/*  462 */     this.buf.putLong(index, value);
/*  463 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public LongBuffer asLongBuffer()
/*      */   {
/*  469 */     return this.buf.asLongBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public float getFloat()
/*      */   {
/*  475 */     return this.buf.getFloat();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putFloat(float value)
/*      */   {
/*  481 */     this.buf.putFloat(value);
/*  482 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public float getFloat(int index)
/*      */   {
/*  488 */     return this.buf.getFloat(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putFloat(int index, float value)
/*      */   {
/*  494 */     this.buf.putFloat(index, value);
/*  495 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public FloatBuffer asFloatBuffer()
/*      */   {
/*  501 */     return this.buf.asFloatBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public double getDouble()
/*      */   {
/*  507 */     return this.buf.getDouble();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putDouble(double value)
/*      */   {
/*  513 */     this.buf.putDouble(value);
/*  514 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public double getDouble(int index)
/*      */   {
/*  520 */     return this.buf.getDouble(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putDouble(int index, double value)
/*      */   {
/*  526 */     this.buf.putDouble(index, value);
/*  527 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public DoubleBuffer asDoubleBuffer()
/*      */   {
/*  533 */     return this.buf.asDoubleBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public String getHexDump()
/*      */   {
/*  539 */     return this.buf.getHexDump();
/*      */   }
/*      */   
/*      */   public String getString(int fieldSize, CharsetDecoder decoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  545 */     return this.buf.getString(fieldSize, decoder);
/*      */   }
/*      */   
/*      */   public String getString(CharsetDecoder decoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  551 */     return this.buf.getString(decoder);
/*      */   }
/*      */   
/*      */   public String getPrefixedString(CharsetDecoder decoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  557 */     return this.buf.getPrefixedString(decoder);
/*      */   }
/*      */   
/*      */   public String getPrefixedString(int prefixLength, CharsetDecoder decoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  563 */     return this.buf.getPrefixedString(prefixLength, decoder);
/*      */   }
/*      */   
/*      */   public IoBuffer putString(CharSequence in, int fieldSize, CharsetEncoder encoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  569 */     this.buf.putString(in, fieldSize, encoder);
/*  570 */     return this;
/*      */   }
/*      */   
/*      */   public IoBuffer putString(CharSequence in, CharsetEncoder encoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  576 */     this.buf.putString(in, encoder);
/*  577 */     return this;
/*      */   }
/*      */   
/*      */   public IoBuffer putPrefixedString(CharSequence in, CharsetEncoder encoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  583 */     this.buf.putPrefixedString(in, encoder);
/*  584 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putPrefixedString(CharSequence in, int prefixLength, CharsetEncoder encoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  591 */     this.buf.putPrefixedString(in, prefixLength, encoder);
/*  592 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putPrefixedString(CharSequence in, int prefixLength, int padding, CharsetEncoder encoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  599 */     this.buf.putPrefixedString(in, prefixLength, padding, encoder);
/*  600 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putPrefixedString(CharSequence in, int prefixLength, int padding, byte padValue, CharsetEncoder encoder)
/*      */     throws CharacterCodingException
/*      */   {
/*  607 */     this.buf.putPrefixedString(in, prefixLength, padding, padValue, encoder);
/*  608 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer skip(int size)
/*      */   {
/*  614 */     this.buf.skip(size);
/*  615 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer fill(byte value, int size)
/*      */   {
/*  621 */     this.buf.fill(value, size);
/*  622 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer fillAndReset(byte value, int size)
/*      */   {
/*  628 */     this.buf.fillAndReset(value, size);
/*  629 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer fill(int size)
/*      */   {
/*  635 */     this.buf.fill(size);
/*  636 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer fillAndReset(int size)
/*      */   {
/*  642 */     this.buf.fillAndReset(size);
/*  643 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean isAutoExpand()
/*      */   {
/*  649 */     return this.buf.isAutoExpand();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer setAutoExpand(boolean autoExpand)
/*      */   {
/*  655 */     this.buf.setAutoExpand(autoExpand);
/*  656 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer expand(int pos, int expectedRemaining)
/*      */   {
/*  662 */     this.buf.expand(pos, expectedRemaining);
/*  663 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer expand(int expectedRemaining)
/*      */   {
/*  669 */     this.buf.expand(expectedRemaining);
/*  670 */     return this;
/*      */   }
/*      */   
/*      */   public Object getObject()
/*      */     throws ClassNotFoundException
/*      */   {
/*  676 */     return this.buf.getObject();
/*      */   }
/*      */   
/*      */   public Object getObject(ClassLoader classLoader)
/*      */     throws ClassNotFoundException
/*      */   {
/*  682 */     return this.buf.getObject(classLoader);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putObject(Object o)
/*      */   {
/*  688 */     this.buf.putObject(o);
/*  689 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public InputStream asInputStream()
/*      */   {
/*  695 */     return this.buf.asInputStream();
/*      */   }
/*      */   
/*      */ 
/*      */   public OutputStream asOutputStream()
/*      */   {
/*  701 */     return this.buf.asOutputStream();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer duplicate()
/*      */   {
/*  707 */     return this.buf.duplicate();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer slice()
/*      */   {
/*  713 */     return this.buf.slice();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer asReadOnlyBuffer()
/*      */   {
/*  719 */     return this.buf.asReadOnlyBuffer();
/*      */   }
/*      */   
/*      */ 
/*      */   public byte[] array()
/*      */   {
/*  725 */     return this.buf.array();
/*      */   }
/*      */   
/*      */ 
/*      */   public int arrayOffset()
/*      */   {
/*  731 */     return this.buf.arrayOffset();
/*      */   }
/*      */   
/*      */ 
/*      */   public int minimumCapacity()
/*      */   {
/*  737 */     return this.buf.minimumCapacity();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer minimumCapacity(int minimumCapacity)
/*      */   {
/*  743 */     this.buf.minimumCapacity(minimumCapacity);
/*  744 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer capacity(int newCapacity)
/*      */   {
/*  750 */     this.buf.capacity(newCapacity);
/*  751 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean isReadOnly()
/*      */   {
/*  757 */     return this.buf.isReadOnly();
/*      */   }
/*      */   
/*      */ 
/*      */   public int markValue()
/*      */   {
/*  763 */     return this.buf.markValue();
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean hasArray()
/*      */   {
/*  769 */     return this.buf.hasArray();
/*      */   }
/*      */   
/*      */ 
/*      */   public void free()
/*      */   {
/*  775 */     this.buf.free();
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean isDerived()
/*      */   {
/*  781 */     return this.buf.isDerived();
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean isAutoShrink()
/*      */   {
/*  787 */     return this.buf.isAutoShrink();
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer setAutoShrink(boolean autoShrink)
/*      */   {
/*  793 */     this.buf.setAutoShrink(autoShrink);
/*  794 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer shrink()
/*      */   {
/*  800 */     this.buf.shrink();
/*  801 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public int getMediumInt()
/*      */   {
/*  807 */     return this.buf.getMediumInt();
/*      */   }
/*      */   
/*      */ 
/*      */   public int getUnsignedMediumInt()
/*      */   {
/*  813 */     return this.buf.getUnsignedMediumInt();
/*      */   }
/*      */   
/*      */ 
/*      */   public int getMediumInt(int index)
/*      */   {
/*  819 */     return this.buf.getMediumInt(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public int getUnsignedMediumInt(int index)
/*      */   {
/*  825 */     return this.buf.getUnsignedMediumInt(index);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putMediumInt(int value)
/*      */   {
/*  831 */     this.buf.putMediumInt(value);
/*  832 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putMediumInt(int index, int value)
/*      */   {
/*  838 */     this.buf.putMediumInt(index, value);
/*  839 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public String getHexDump(int lengthLimit)
/*      */   {
/*  845 */     return this.buf.getHexDump(lengthLimit);
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean prefixedDataAvailable(int prefixLength)
/*      */   {
/*  851 */     return this.buf.prefixedDataAvailable(prefixLength);
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean prefixedDataAvailable(int prefixLength, int maxDataLength)
/*      */   {
/*  857 */     return this.buf.prefixedDataAvailable(prefixLength, maxDataLength);
/*      */   }
/*      */   
/*      */ 
/*      */   public int indexOf(byte b)
/*      */   {
/*  863 */     return this.buf.indexOf(b);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> E getEnum(Class<E> enumClass)
/*      */   {
/*  869 */     return this.buf.getEnum(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> E getEnum(int index, Class<E> enumClass)
/*      */   {
/*  875 */     return this.buf.getEnum(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> E getEnumShort(Class<E> enumClass)
/*      */   {
/*  881 */     return this.buf.getEnumShort(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> E getEnumShort(int index, Class<E> enumClass)
/*      */   {
/*  887 */     return this.buf.getEnumShort(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> E getEnumInt(Class<E> enumClass)
/*      */   {
/*  893 */     return this.buf.getEnumInt(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> E getEnumInt(int index, Class<E> enumClass)
/*      */   {
/*  899 */     return this.buf.getEnumInt(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putEnum(Enum<?> e)
/*      */   {
/*  905 */     this.buf.putEnum(e);
/*  906 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putEnum(int index, Enum<?> e)
/*      */   {
/*  912 */     this.buf.putEnum(index, e);
/*  913 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putEnumShort(Enum<?> e)
/*      */   {
/*  919 */     this.buf.putEnumShort(e);
/*  920 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putEnumShort(int index, Enum<?> e)
/*      */   {
/*  926 */     this.buf.putEnumShort(index, e);
/*  927 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putEnumInt(Enum<?> e)
/*      */   {
/*  933 */     this.buf.putEnumInt(e);
/*  934 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public IoBuffer putEnumInt(int index, Enum<?> e)
/*      */   {
/*  940 */     this.buf.putEnumInt(index, e);
/*  941 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSet(Class<E> enumClass)
/*      */   {
/*  947 */     return this.buf.getEnumSet(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSet(int index, Class<E> enumClass)
/*      */   {
/*  953 */     return this.buf.getEnumSet(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSetShort(Class<E> enumClass)
/*      */   {
/*  959 */     return this.buf.getEnumSetShort(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSetShort(int index, Class<E> enumClass)
/*      */   {
/*  965 */     return this.buf.getEnumSetShort(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSetInt(Class<E> enumClass)
/*      */   {
/*  971 */     return this.buf.getEnumSetInt(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSetInt(int index, Class<E> enumClass)
/*      */   {
/*  977 */     return this.buf.getEnumSetInt(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSetLong(Class<E> enumClass)
/*      */   {
/*  983 */     return this.buf.getEnumSetLong(enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> EnumSet<E> getEnumSetLong(int index, Class<E> enumClass)
/*      */   {
/*  989 */     return this.buf.getEnumSetLong(index, enumClass);
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSet(Set<E> set)
/*      */   {
/*  995 */     this.buf.putEnumSet(set);
/*  996 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSet(int index, Set<E> set)
/*      */   {
/* 1002 */     this.buf.putEnumSet(index, set);
/* 1003 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSetShort(Set<E> set)
/*      */   {
/* 1009 */     this.buf.putEnumSetShort(set);
/* 1010 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSetShort(int index, Set<E> set)
/*      */   {
/* 1016 */     this.buf.putEnumSetShort(index, set);
/* 1017 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSetInt(Set<E> set)
/*      */   {
/* 1023 */     this.buf.putEnumSetInt(set);
/* 1024 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSetInt(int index, Set<E> set)
/*      */   {
/* 1030 */     this.buf.putEnumSetInt(index, set);
/* 1031 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSetLong(Set<E> set)
/*      */   {
/* 1037 */     this.buf.putEnumSetLong(set);
/* 1038 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public <E extends Enum<E>> IoBuffer putEnumSetLong(int index, Set<E> set)
/*      */   {
/* 1044 */     this.buf.putEnumSetLong(index, set);
/* 1045 */     return this;
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\buffer\IoBufferWrapper.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */