/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.JSClientException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.AttachmentDescriptor;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ExportDescriptor;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ReportExecutionStatusEntity;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ExportExecutionRequestBuilder
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private String requestId;
/*     */   private String exportId;
/*     */   
/*     */   public ExportExecutionRequestBuilder(SessionStorage sessionStorage, String requestId, String exportId)
/*     */   {
/*  48 */     super(sessionStorage);
/*  49 */     this.requestId = requestId;
/*  50 */     this.exportId = exportId;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private OperationResult outputResource(boolean isHtmlExport)
/*     */   {
/*  58 */     return JerseyRequest.buildRequest(this.sessionStorage, isHtmlExport ? String.class : InputStream.class, new String[] { "/reportExecutions", this.requestId, "/exports", this.exportId, "/outputResource" }).get();
/*     */   }
/*     */   
/*     */ 
/*     */   public OperationResult<InputStream> outputResource()
/*     */   {
/*  64 */     return outputResource(false);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncOutputResource(final Callback<OperationResult<InputStream>, R> callback) {
/*  68 */     final JerseyRequest<InputStream> request = JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/reportExecutions", this.requestId, "/exports", this.exportId, "/outputResource" });
/*     */     
/*     */ 
/*     */ 
/*  72 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  75 */         callback.execute(request.get());
/*     */       }
/*     */       
/*  78 */     });
/*  79 */     ThreadPoolUtil.runAsynchronously(task);
/*  80 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<InputStream> attachment(String attachmentId)
/*     */   {
/*  85 */     if (("".equals(attachmentId)) || ("/".equals(attachmentId))) {
/*  86 */       throw new IllegalArgumentException("'attachmentId' mustn't be an empty string");
/*     */     }
/*  88 */     while (!"ready".equals(((ReportExecutionStatusEntity)status().getEntity()).getValue())) {
/*     */       try {
/*  90 */         Thread.sleep(500L);
/*     */       }
/*     */       catch (InterruptedException ignored) {}
/*     */     }
/*     */     
/*  95 */     return JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/reportExecutions", this.requestId, "/exports", this.exportId, "/attachments", attachmentId }).get();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public <R> RequestExecution asyncAttachment(String attachmentId, final Callback<OperationResult<InputStream>, R> callback)
/*     */   {
/* 102 */     if (("".equals(attachmentId)) || ("/".equals(attachmentId))) {
/* 103 */       throw new IllegalArgumentException("'attachmentId' mustn't be an empty string");
/*     */     }
/* 105 */     final JerseyRequest<InputStream> request = JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/reportExecutions", this.requestId, "/exports", this.exportId, "/attachments", attachmentId });
/*     */     
/*     */ 
/*     */ 
/* 109 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 112 */         while (!"ready".equals(((ReportExecutionStatusEntity)ExportExecutionRequestBuilder.this.status().getEntity()).getValue())) {
/*     */           try {
/* 114 */             Thread.sleep(500L);
/*     */           }
/*     */           catch (InterruptedException ignored) {}
/*     */         }
/* 118 */         callback.execute(request.get());
/*     */       }
/*     */       
/* 121 */     });
/* 122 */     ThreadPoolUtil.runAsynchronously(task);
/* 123 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ReportExecutionStatusEntity> status() {
/* 127 */     return JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionStatusEntity.class, new String[] { "/reportExecutions", this.requestId, "/exports", this.exportId, "/status" }).get();
/*     */   }
/*     */   
/*     */ 
/*     */   public <R> RequestExecution asyncStatus(final Callback<OperationResult<ReportExecutionStatusEntity>, R> callback)
/*     */   {
/* 133 */     final JerseyRequest<ReportExecutionStatusEntity> request = JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionStatusEntity.class, new String[] { "/reportExecutions", this.requestId, "/exports", this.exportId, "/status" });
/*     */     
/*     */ 
/*     */ 
/* 137 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 140 */         callback.execute(request.get());
/*     */       }
/*     */       
/* 143 */     });
/* 144 */     ThreadPoolUtil.runAsynchronously(task);
/* 145 */     return task;
/*     */   }
/*     */   
/*     */   public HtmlReport htmlReport(ExportDescriptor htmlExport)
/*     */   {
/* 150 */     HtmlReport htmlReport = new HtmlReport(htmlExport.getId());
/*     */     
/* 152 */     OperationResult<String> markup = outputResource(true);
/* 153 */     htmlReport.setHtml((String)markup.getEntity());
/*     */     
/* 155 */     List<AttachmentDescriptor> attachments = htmlExport.getAttachments();
/* 156 */     if (attachments != null) {
/* 157 */       for (AttachmentDescriptor attachmentDescriptor : attachments) {
/* 158 */         String fileName = attachmentDescriptor.getFileName();
/* 159 */         OperationResult<InputStream> streamOperationResult = attachment(fileName);
/*     */         
/* 161 */         Attachment attachment = new Attachment();
/* 162 */         attachment.setName(attachmentDescriptor.getFileName());
/* 163 */         attachment.setMimeType(attachmentDescriptor.getContentType());
/* 164 */         attachment.setContent(toByteArray((InputStream)streamOperationResult.getEntity()));
/*     */         
/* 166 */         htmlReport.addAttachment(attachment);
/*     */       }
/*     */     }
/*     */     
/* 170 */     return htmlReport;
/*     */   }
/*     */   
/*     */ 
/*     */   public <R> RequestExecution asyncHtmlReport(final ExportDescriptor htmlExport, final Callback<HtmlReport, R> callback)
/*     */   {
/* 176 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 179 */         callback.execute(ExportExecutionRequestBuilder.this.htmlReport(htmlExport));
/*     */       }
/*     */       
/* 182 */     });
/* 183 */     ThreadPoolUtil.runAsynchronously(task);
/* 184 */     return task;
/*     */   }
/*     */   
/*     */   private byte[] toByteArray(InputStream is) {
/*     */     try {
/* 189 */       List<Byte> bytes = new ArrayList();
/* 190 */       byte[] buff = new byte['Ѐ'];
/* 191 */       while (is.read(buff) != -1) {
/* 192 */         for (byte b : buff) {
/* 193 */           bytes.add(Byte.valueOf(b));
/*     */         }
/*     */       }
/* 196 */       byte[] result = new byte[bytes.size()];
/* 197 */       for (int i = 0; i < bytes.size(); i++) {
/* 198 */         result[i] = ((Byte)bytes.get(i)).byteValue();
/*     */       }
/* 200 */       return result;
/*     */     } catch (IOException e) {
/* 202 */       throw new JSClientException("Error while reading thumbnail content", e);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\reporting\ExportExecutionRequestBuilder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */