/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.dto.common.PatchDescriptor;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientFile;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientFile.FileType;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientResource;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientSemanticLayerDataSource;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.MimeTypeUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.sun.jersey.multipart.FormDataMultiPart;
/*     */ import java.io.File;
/*     */ import java.io.InputStream;
/*     */ import javax.ws.rs.core.MediaType;
/*     */ import javax.ws.rs.core.MultivaluedHashMap;
/*     */ import javax.ws.rs.core.MultivaluedMap;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SingleResourceAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private final String resourceUri;
/*     */   private final MultivaluedMap<String, String> params;
/*     */   
/*     */   public SingleResourceAdapter(SessionStorage sessionStorage, String resourceUri)
/*     */   {
/*  52 */     super(sessionStorage);
/*  53 */     this.resourceUri = resourceUri;
/*  54 */     this.params = new MultivaluedHashMap();
/*     */   }
/*     */   
/*     */   public SingleResourceAdapter parameter(ResourceServiceParameter param, String value) {
/*  58 */     this.params.add(param.getName(), value);
/*  59 */     return this;
/*     */   }
/*     */   
/*     */   public OperationResult<ClientResource> details() {
/*  63 */     JerseyRequest<ClientResource> request = prepareDetailsRequest();
/*  64 */     return request.get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDetails(final Callback<OperationResult<ClientResource>, R> callback) {
/*  68 */     final JerseyRequest<ClientResource> request = prepareDetailsRequest();
/*  69 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  72 */         callback.execute(request.get());
/*     */       }
/*  74 */     });
/*  75 */     ThreadPoolUtil.runAsynchronously(task);
/*  76 */     return task;
/*     */   }
/*     */   
/*     */   private JerseyRequest<ClientResource> prepareDetailsRequest() {
/*  80 */     JerseyRequest<ClientResource> request = JerseyRequest.buildRequest(this.sessionStorage, ClientResource.class, new String[] { "/resources", this.resourceUri });
/*  81 */     request.addParams(this.params);
/*  82 */     if (isRootFolder(this.resourceUri)) {
/*  83 */       request.setAccept("application/repository.folder+json");
/*     */     } else {
/*  85 */       request.setAccept("application/repository.file+json");
/*     */     }
/*  87 */     return request;
/*     */   }
/*     */   
/*     */   private boolean isRootFolder(String resourceUri) {
/*  91 */     return ("/".equals(resourceUri)) || ("".equals(resourceUri));
/*     */   }
/*     */   
/*     */   public OperationResult<InputStream> downloadBinary() {
/*  95 */     return JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/resources", this.resourceUri }).get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDownloadBinary(final Callback<OperationResult<InputStream>, R> callback) {
/*  99 */     final JerseyRequest<InputStream> request = JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/resources", this.resourceUri });
/* 100 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 103 */         callback.execute(request.get());
/*     */       }
/* 105 */     });
/* 106 */     ThreadPoolUtil.runAsynchronously(task);
/* 107 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ClientResource> createOrUpdate(ClientResource resource) {
/* 111 */     return prepareCreateOrUpdateRequest(resource).put(resource);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreateOrUpdate(final ClientResource resource, final Callback<OperationResult<ClientResource>, R> callback) {
/* 115 */     final JerseyRequest<ClientResource> request = prepareCreateOrUpdateRequest(resource);
/* 116 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 119 */         callback.execute(request.put(resource));
/*     */       }
/* 121 */     });
/* 122 */     ThreadPoolUtil.runAsynchronously(task);
/* 123 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ClientResource> createNew(ClientResource resource) {
/* 127 */     return prepareCreateOrUpdateRequest(resource).post(resource);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreateNew(final ClientResource resource, final Callback<OperationResult<ClientResource>, R> callback) {
/* 131 */     final JerseyRequest<ClientResource> request = prepareCreateOrUpdateRequest(resource);
/* 132 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 135 */         callback.execute(request.post(resource));
/*     */       }
/* 137 */     });
/* 138 */     ThreadPoolUtil.runAsynchronously(task);
/* 139 */     return task;
/*     */   }
/*     */   
/*     */   private JerseyRequest<ClientResource> prepareCreateOrUpdateRequest(ClientResource resource) {
/* 143 */     Class<? extends ClientResource> resourceType = ResourcesTypeResolverUtil.getResourceType(resource);
/* 144 */     JerseyRequest<? extends ClientResource> request = JerseyRequest.buildRequest(this.sessionStorage, resourceType, new String[] { "/resources", this.resourceUri }, new DefaultErrorHandler());
/* 145 */     request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), ResourcesTypeResolverUtil.getMimeType(resourceType)));
/* 146 */     request.addParams(this.params);
/* 147 */     return request;
/*     */   }
/*     */   
/*     */   public OperationResult<ClientResource> copyFrom(String fromUri) {
/* 151 */     return copyOrMove(false, fromUri);
/*     */   }
/*     */   
/*     */   public OperationResult<ClientResource> moveFrom(String fromUri) {
/* 155 */     return copyOrMove(true, fromUri);
/*     */   }
/*     */   
/*     */   private OperationResult<ClientResource> copyOrMove(boolean moving, String fromUri) {
/* 159 */     JerseyRequest<ClientResource> request = prepareCopyOrMoveRequest(fromUri);
/* 160 */     if (moving) {
/* 161 */       return request.put("");
/*     */     }
/* 163 */     return request.post(null);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCopyOrMove(final boolean moving, String fromUri, final Callback<OperationResult<ClientResource>, R> callback)
/*     */   {
/* 168 */     final JerseyRequest<ClientResource> request = prepareCopyOrMoveRequest(fromUri);
/*     */     
/* 170 */     RequestExecution task = new RequestExecution(new Runnable() {
/*     */       public void run() {
/*     */         OperationResult<ClientResource> result;
/*     */         OperationResult<ClientResource> result;
/* 174 */         if (moving) {
/* 175 */           result = request.put("");
/*     */         } else {
/* 177 */           result = request.post(null);
/*     */         }
/* 179 */         callback.execute(result);
/*     */       }
/*     */       
/* 182 */     });
/* 183 */     ThreadPoolUtil.runAsynchronously(task);
/* 184 */     return task;
/*     */   }
/*     */   
/*     */   private JerseyRequest<ClientResource> prepareCopyOrMoveRequest(String fromUri) {
/* 188 */     JerseyRequest<ClientResource> request = JerseyRequest.buildRequest(this.sessionStorage, ClientResource.class, new String[] { "/resources", this.resourceUri }, new DefaultErrorHandler());
/* 189 */     request.addParams(this.params);
/* 190 */     request.addHeader("Content-Location", new String[] { fromUri });
/* 191 */     return request;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T> OperationResult<T> uploadMultipartResource(FormDataMultiPart multipartResource, Class<T> clazz)
/*     */   {
/* 203 */     JerseyRequest<T> request = JerseyRequest.buildRequest(this.sessionStorage, clazz, new String[] { "/resources", this.resourceUri });
/* 204 */     request.setContentType("multipart/form-data");
/* 205 */     return request.post(multipartResource);
/*     */   }
/*     */   
/*     */   public <T> OperationResult<T> get(Class<T> clazz) {
/* 209 */     JerseyRequest<T> request = JerseyRequest.buildRequest(this.sessionStorage, clazz, new String[] { "/resources", this.resourceUri });
/* 210 */     return request.get();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public OperationResult<ClientFile> uploadFile(File fileContent, ClientFile.FileType fileType, String label, String description)
/*     */   {
/* 217 */     FormDataMultiPart form = prepareUploadForm(fileContent, fileType, label, description);
/* 218 */     JerseyRequest<ClientFile> request = prepareUploadFileRequest();
/* 219 */     return request.post(form);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public <R> RequestExecution asyncUploadFile(File fileContent, ClientFile.FileType fileType, String label, String description, final Callback<OperationResult<ClientFile>, R> callback)
/*     */   {
/* 227 */     final FormDataMultiPart form = prepareUploadForm(fileContent, fileType, label, description);
/* 228 */     final JerseyRequest<ClientFile> request = prepareUploadFileRequest();
/* 229 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 232 */         callback.execute(request.post(form));
/*     */       }
/* 234 */     });
/* 235 */     ThreadPoolUtil.runAsynchronously(task);
/* 236 */     return task;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private FormDataMultiPart prepareUploadForm(File fileContent, ClientFile.FileType fileType, String label, String description)
/*     */   {
/* 243 */     FormDataMultiPart form = new FormDataMultiPart();
/* 244 */     form.field("data", fileContent, MediaType.WILDCARD_TYPE).field("label", label).field("description", description).field("type", fileType.name());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 249 */     return form;
/*     */   }
/*     */   
/*     */   private JerseyRequest<ClientFile> prepareUploadFileRequest() {
/* 253 */     JerseyRequest<ClientFile> request = JerseyRequest.buildRequest(this.sessionStorage, ClientFile.class, new String[] { "/resources", this.resourceUri });
/* 254 */     request.addParams(this.params);
/* 255 */     request.setContentType("multipart/form-data");
/* 256 */     return request;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private JerseyRequest<ClientSemanticLayerDataSource> prepareUploadResourcesRequest()
/*     */   {
/* 265 */     JerseyRequest<ClientSemanticLayerDataSource> request = JerseyRequest.buildRequest(this.sessionStorage, ClientSemanticLayerDataSource.class, new String[] { "/resources", this.resourceUri });
/* 266 */     request.setContentType("multipart/form-data");
/* 267 */     return request;
/*     */   }
/*     */   
/*     */   public OperationResult delete() {
/* 271 */     JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/resources", this.resourceUri });
/* 272 */     return request.delete();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback) {
/* 276 */     final JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/resources", this.resourceUri });
/* 277 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 280 */         callback.execute(request.delete());
/*     */       }
/* 282 */     });
/* 283 */     ThreadPoolUtil.runAsynchronously(task);
/* 284 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ClientResource> patchResource(PatchDescriptor descriptor) {
/* 288 */     throw new UnsupportedOperationException("Server doesn't return proper MIME-type inFolder resolve entity type");
/*     */   }
/*     */   
/*     */   public <ResourceType extends ClientResource> OperationResult<ResourceType> patchResource(Class<ResourceType> resourceTypeClass, PatchDescriptor descriptor) {
/* 292 */     JerseyRequest<ResourceType> request = preparePatchResourceRequest(resourceTypeClass);
/* 293 */     return request.post(descriptor);
/*     */   }
/*     */   
/*     */ 
/*     */   public <ResourceType extends ClientResource, R> RequestExecution asyncPatchResource(Class<ResourceType> resourceTypeClass, final PatchDescriptor descriptor, final Callback<OperationResult<ResourceType>, R> callback)
/*     */   {
/* 299 */     final JerseyRequest request = preparePatchResourceRequest(resourceTypeClass);
/* 300 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 303 */         callback.execute(request.post(descriptor));
/*     */       }
/* 305 */     });
/* 306 */     ThreadPoolUtil.runAsynchronously(task);
/* 307 */     return task;
/*     */   }
/*     */   
/*     */   private <ResourceType extends ClientResource> JerseyRequest<ResourceType> preparePatchResourceRequest(Class<ResourceType> resourceTypeClass) {
/* 311 */     JerseyRequest<ResourceType> request = JerseyRequest.buildRequest(this.sessionStorage, resourceTypeClass, new String[] { "/resources", this.resourceUri });
/* 312 */     request.setAccept(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), ResourcesTypeResolverUtil.getMimeType(resourceTypeClass)));
/* 313 */     request.addHeader("X-HTTP-Method-Override", new String[] { "PATCH" });
/* 314 */     return request;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\resources\SingleResourceAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */