/*     */ package com.sun.xml.bind.marshaller;
/*     */ 
/*     */ import com.sun.istack.FinalArrayList;
/*     */ import com.sun.xml.bind.util.Which;
/*     */ import java.util.Stack;
/*     */ import javax.xml.parsers.DocumentBuilder;
/*     */ import javax.xml.parsers.DocumentBuilderFactory;
/*     */ import javax.xml.parsers.ParserConfigurationException;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.Text;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.Locator;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SAX2DOMEx
/*     */   implements ContentHandler
/*     */ {
/*  53 */   private Node node = null;
/*  54 */   private final Stack<Node> nodeStack = new Stack();
/*  55 */   private final FinalArrayList<String> unprocessedNamespaces = new FinalArrayList();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final Document document;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SAX2DOMEx(Node node)
/*     */   {
/*  69 */     this.node = node;
/*  70 */     this.nodeStack.push(this.node);
/*     */     
/*  72 */     if ((node instanceof Document)) {
/*  73 */       this.document = ((Document)node);
/*     */     } else {
/*  75 */       this.document = node.getOwnerDocument();
/*     */     }
/*     */   }
/*     */   
/*     */   public SAX2DOMEx()
/*     */     throws ParserConfigurationException
/*     */   {
/*  82 */     DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
/*  83 */     factory.setNamespaceAware(true);
/*  84 */     factory.setValidating(false);
/*     */     
/*  86 */     this.document = factory.newDocumentBuilder().newDocument();
/*  87 */     this.node = this.document;
/*  88 */     this.nodeStack.push(this.document);
/*     */   }
/*     */   
/*     */   public final Element getCurrentElement() {
/*  92 */     return (Element)this.nodeStack.peek();
/*     */   }
/*     */   
/*     */   public Node getDOM() {
/*  96 */     return this.node;
/*     */   }
/*     */   
/*     */ 
/*     */   public void startDocument() {}
/*     */   
/*     */   public void endDocument() {}
/*     */   
/*     */   public void startElement(String namespace, String localName, String qName, Attributes attrs)
/*     */   {
/* 106 */     Node parent = (Node)this.nodeStack.peek();
/*     */     
/*     */ 
/*     */ 
/* 110 */     Element element = this.document.createElementNS(namespace, qName);
/*     */     
/* 112 */     if (element == null)
/*     */     {
/*     */ 
/* 115 */       throw new AssertionError(Messages.format("SAX2DOMEx.DomImplDoesntSupportCreateElementNs", this.document.getClass().getName(), Which.which(this.document.getClass())));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 122 */     for (int i = 0; i < this.unprocessedNamespaces.size(); i += 2) {
/* 123 */       String prefix = (String)this.unprocessedNamespaces.get(i + 0);
/* 124 */       String uri = (String)this.unprocessedNamespaces.get(i + 1);
/*     */       String qname;
/*     */       String qname;
/* 127 */       if (("".equals(prefix)) || (prefix == null)) {
/* 128 */         qname = "xmlns";
/*     */       } else {
/* 130 */         qname = "xmlns:" + prefix;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 135 */       if (element.hasAttributeNS("http://www.w3.org/2000/xmlns/", qname))
/*     */       {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 143 */         element.removeAttributeNS("http://www.w3.org/2000/xmlns/", qname);
/*     */       }
/*     */       
/*     */ 
/* 147 */       element.setAttributeNS("http://www.w3.org/2000/xmlns/", qname, uri);
/*     */     }
/* 149 */     this.unprocessedNamespaces.clear();
/*     */     
/*     */ 
/* 152 */     int length = attrs.getLength();
/* 153 */     for (int i = 0; i < length; i++) {
/* 154 */       String namespaceuri = attrs.getURI(i);
/* 155 */       String value = attrs.getValue(i);
/* 156 */       String qname = attrs.getQName(i);
/* 157 */       element.setAttributeNS(namespaceuri, qname, value);
/*     */     }
/*     */     
/* 160 */     parent.appendChild(element);
/*     */     
/* 162 */     this.nodeStack.push(element);
/*     */   }
/*     */   
/*     */   public void endElement(String namespace, String localName, String qName) {
/* 166 */     this.nodeStack.pop();
/*     */   }
/*     */   
/*     */   public void characters(char[] ch, int start, int length)
/*     */   {
/* 171 */     Node parent = (Node)this.nodeStack.peek();
/* 172 */     Text text = this.document.createTextNode(new String(ch, start, length));
/* 173 */     parent.appendChild(text);
/*     */   }
/*     */   
/*     */ 
/*     */   public void ignorableWhitespace(char[] ch, int start, int length) {}
/*     */   
/*     */   public void processingInstruction(String target, String data)
/*     */     throws SAXException
/*     */   {
/* 182 */     Node parent = (Node)this.nodeStack.peek();
/* 183 */     Node node = this.document.createProcessingInstruction(target, data);
/* 184 */     parent.appendChild(node);
/*     */   }
/*     */   
/*     */ 
/*     */   public void setDocumentLocator(Locator locator) {}
/*     */   
/*     */   public void skippedEntity(String name) {}
/*     */   
/*     */   public void startPrefixMapping(String prefix, String uri)
/*     */   {
/* 194 */     this.unprocessedNamespaces.add(prefix);
/* 195 */     this.unprocessedNamespaces.add(uri);
/*     */   }
/*     */   
/*     */   public void endPrefixMapping(String prefix) {}
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\marshaller\SAX2DOMEx.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */