/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.istack.Pool;
/*     */ import com.sun.istack.Pool.Impl;
/*     */ import com.sun.xml.bind.DatatypeConverterImpl;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.api.Bridge;
/*     */ import com.sun.xml.bind.api.BridgeContext;
/*     */ import com.sun.xml.bind.api.CompositeStructure;
/*     */ import com.sun.xml.bind.api.JAXBRIContext;
/*     */ import com.sun.xml.bind.api.RawAccessor;
/*     */ import com.sun.xml.bind.api.TypeReference;
/*     */ import com.sun.xml.bind.unmarshaller.DOMScanner;
/*     */ import com.sun.xml.bind.util.Which;
/*     */ import com.sun.xml.bind.v2.model.annotation.RuntimeInlineAnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.core.Adapter;
/*     */ import com.sun.xml.bind.v2.model.core.NonElement;
/*     */ import com.sun.xml.bind.v2.model.core.Ref;
/*     */ import com.sun.xml.bind.v2.model.impl.RuntimeBuiltinLeafInfoImpl;
/*     */ import com.sun.xml.bind.v2.model.impl.RuntimeModelBuilder;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeArrayInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeBuiltinLeafInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeClassInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeEnumLeafInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeLeafInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfoSet;
/*     */ import com.sun.xml.bind.v2.runtime.output.Encoded;
/*     */ import com.sun.xml.bind.v2.runtime.property.AttributeProperty;
/*     */ import com.sun.xml.bind.v2.runtime.property.Property;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.TagName;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallerImpl;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import com.sun.xml.bind.v2.schemagen.XmlSchemaGenerator;
/*     */ import com.sun.xml.bind.v2.util.EditDistance;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import com.sun.xml.bind.v2.util.QNameMap.Entry;
/*     */ import java.io.IOException;
/*     */ import java.lang.ref.WeakReference;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.Arrays;
/*     */ import java.util.Collection;
/*     */ import java.util.Comparator;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.LinkedHashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import java.util.TreeSet;
/*     */ import javax.xml.bind.Binder;
/*     */ import javax.xml.bind.DatatypeConverter;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.JAXBIntrospector;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import javax.xml.bind.SchemaOutputResolver;
/*     */ import javax.xml.bind.Unmarshaller;
/*     */ import javax.xml.bind.Validator;
/*     */ import javax.xml.bind.annotation.XmlAttachmentRef;
/*     */ import javax.xml.bind.annotation.XmlList;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.parsers.DocumentBuilder;
/*     */ import javax.xml.parsers.DocumentBuilderFactory;
/*     */ import javax.xml.parsers.FactoryConfigurationError;
/*     */ import javax.xml.parsers.ParserConfigurationException;
/*     */ import javax.xml.transform.Result;
/*     */ import javax.xml.transform.sax.SAXResult;
/*     */ import javax.xml.transform.sax.SAXTransformerFactory;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.DefaultHandler;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class JAXBContextImpl
/*     */   extends JAXBRIContext
/*     */ {
/* 120 */   private final Map<TypeReference, Bridge> bridges = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static SAXTransformerFactory tf;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private static DocumentBuilder db;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 136 */   private final QNameMap<JaxBeanInfo> rootMap = new QNameMap();
/* 137 */   private final HashMap<QName, JaxBeanInfo> typeMap = new HashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 142 */   private final Map<Class, JaxBeanInfo> beanInfoMap = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 153 */   protected Map<RuntimeTypeInfo, JaxBeanInfo> beanInfos = new LinkedHashMap();
/*     */   
/* 155 */   private final Map<Class, Map<QName, ElementBeanInfoImpl>> elements = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 160 */   public final Pool<Marshaller> marshallerPool = new Pool.Impl() {
/*     */     @NotNull
/* 162 */     protected Marshaller create() { return JAXBContextImpl.this.createMarshaller(); }
/*     */   };
/*     */   
/*     */ 
/* 166 */   public final Pool<Unmarshaller> unmarshallerPool = new Pool.Impl() {
/*     */     @NotNull
/* 168 */     protected Unmarshaller create() { return JAXBContextImpl.this.createUnmarshaller(); }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 176 */   public NameBuilder nameBuilder = new NameBuilder();
/*     */   
/*     */ 
/*     */ 
/*     */   public final NameList nameList;
/*     */   
/*     */ 
/*     */ 
/*     */   private final String defaultNsUri;
/*     */   
/*     */ 
/*     */ 
/*     */   private final Class[] classes;
/*     */   
/*     */ 
/*     */ 
/*     */   protected final boolean c14nSupport;
/*     */   
/*     */ 
/*     */ 
/*     */   private WeakReference<RuntimeTypeInfoSet> typeInfoSetCache;
/*     */   
/*     */ 
/*     */ 
/*     */   private Encoded[] utf8nameTable;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public JAXBContextImpl(Class[] classes, Collection<TypeReference> typeRefs, String defaultNsUri, boolean c14nSupport)
/*     */     throws JAXBException
/*     */   {
/* 208 */     DatatypeConverter.setDatatypeConverter(DatatypeConverterImpl.theInstance);
/*     */     
/* 210 */     if (defaultNsUri == null) { defaultNsUri = "";
/*     */     }
/* 212 */     this.defaultNsUri = defaultNsUri;
/* 213 */     this.c14nSupport = c14nSupport;
/* 214 */     this.classes = new Class[classes.length];
/* 215 */     System.arraycopy(classes, 0, this.classes, 0, classes.length);
/*     */     
/* 217 */     RuntimeTypeInfoSet typeSet = getTypeInfoSet();
/*     */     
/*     */ 
/*     */ 
/* 221 */     this.elements.put(null, new LinkedHashMap());
/*     */     
/*     */ 
/* 224 */     for (RuntimeBuiltinLeafInfo leaf : RuntimeBuiltinLeafInfoImpl.builtinBeanInfos) {
/* 225 */       bi = new LeafBeanInfoImpl(this, leaf);
/* 226 */       this.beanInfoMap.put(leaf.getClazz(), bi);
/* 227 */       for (QName t : bi.getTypeNames())
/* 228 */         this.typeMap.put(t, bi);
/*     */     }
/*     */     LeafBeanInfoImpl<?> bi;
/* 231 */     for (RuntimeEnumLeafInfo e : typeSet.enums().values()) {
/* 232 */       JaxBeanInfo<?> bi = getOrCreate(e);
/* 233 */       for (QName qn : bi.getTypeNames())
/* 234 */         this.typeMap.put(qn, bi);
/* 235 */       if (e.isElement()) {
/* 236 */         this.rootMap.put(e.getElementName(), bi);
/*     */       }
/*     */     }
/* 239 */     for (RuntimeArrayInfo a : typeSet.arrays().values()) {
/* 240 */       ai = getOrCreate(a);
/* 241 */       for (QName qn : ai.getTypeNames())
/* 242 */         this.typeMap.put(qn, ai);
/*     */     }
/*     */     JaxBeanInfo<?> ai;
/* 245 */     for (RuntimeClassInfo ci : typeSet.beans().values()) {
/* 246 */       bi = getOrCreate(ci);
/*     */       
/* 248 */       if (bi.isElement()) {
/* 249 */         this.rootMap.put(ci.getElementName(), bi);
/*     */       }
/* 251 */       for (QName qn : bi.getTypeNames()) {
/* 252 */         this.typeMap.put(qn, bi);
/*     */       }
/*     */     }
/*     */     ClassBeanInfoImpl<?> bi;
/* 256 */     for (RuntimeElementInfo n : typeSet.getAllElements()) {
/* 257 */       ElementBeanInfoImpl bi = getOrCreate(n);
/* 258 */       if (n.getScope() == null) {
/* 259 */         this.rootMap.put(n.getElementName(), bi);
/*     */       }
/* 261 */       RuntimeClassInfo scope = n.getScope();
/* 262 */       Class scopeClazz = scope == null ? null : (Class)scope.getClazz();
/* 263 */       Map<QName, ElementBeanInfoImpl> m = (Map)this.elements.get(scopeClazz);
/* 264 */       if (m == null) {
/* 265 */         m = new LinkedHashMap();
/* 266 */         this.elements.put(scopeClazz, m);
/*     */       }
/* 268 */       m.put(n.getElementName(), bi);
/*     */     }
/*     */     
/*     */ 
/* 272 */     this.beanInfoMap.put(JAXBElement.class, new ElementBeanInfoImpl(this));
/*     */     
/* 274 */     this.beanInfoMap.put(CompositeStructure.class, new CompositeStructureBeanInfo(this));
/*     */     
/* 276 */     getOrCreate(typeSet.getAnyTypeInfo());
/*     */     
/*     */ 
/* 279 */     for (JaxBeanInfo bi : this.beanInfos.values()) {
/* 280 */       bi.link(this);
/*     */     }
/*     */     
/* 283 */     for (Map.Entry<Class, Class> e : RuntimeUtil.primitiveToBox.entrySet()) {
/* 284 */       this.beanInfoMap.put(e.getKey(), this.beanInfoMap.get(e.getValue()));
/*     */     }
/*     */     
/* 287 */     ReflectionNavigator nav = typeSet.getNavigator();
/*     */     
/* 289 */     for (TypeReference tr : typeRefs) {
/* 290 */       XmlJavaTypeAdapter xjta = (XmlJavaTypeAdapter)tr.get(XmlJavaTypeAdapter.class);
/* 291 */       Adapter<Type, Class> a = null;
/* 292 */       XmlList xl = (XmlList)tr.get(XmlList.class);
/*     */       
/*     */ 
/* 295 */       Class erasedType = nav.erasure(tr.type);
/*     */       
/* 297 */       if (xjta != null) {
/* 298 */         a = new Adapter(xjta.value(), nav);
/*     */       }
/* 300 */       if (tr.get(XmlAttachmentRef.class) != null) {
/* 301 */         a = new Adapter(SwaRefAdapter.class, nav);
/*     */       }
/*     */       
/* 304 */       if (a != null) {
/* 305 */         erasedType = nav.erasure((Type)a.defaultType);
/*     */       }
/*     */       
/* 308 */       Name name = this.nameBuilder.createElementName(tr.tagName);
/*     */       InternalBridge bridge;
/*     */       InternalBridge bridge;
/* 311 */       if (xl == null) {
/* 312 */         bridge = new BridgeImpl(this, name, getBeanInfo(erasedType, true), tr);
/*     */       } else {
/* 314 */         bridge = new BridgeImpl(this, name, new ValueListBeanInfoImpl(this, erasedType), tr);
/*     */       }
/* 316 */       if (a != null) {
/* 317 */         bridge = new BridgeAdapter(bridge, (Class)a.adapterType);
/*     */       }
/* 319 */       this.bridges.put(tr, bridge);
/*     */     }
/*     */     
/*     */ 
/* 323 */     this.nameList = this.nameBuilder.conclude();
/*     */     
/* 325 */     for (JaxBeanInfo bi : this.beanInfos.values()) {
/* 326 */       bi.wrapUp();
/*     */     }
/*     */     
/* 329 */     this.nameBuilder = null;
/* 330 */     this.beanInfos = null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private RuntimeTypeInfoSet getTypeInfoSet()
/*     */     throws IllegalAnnotationsException
/*     */   {
/* 339 */     if (this.typeInfoSetCache != null) {
/* 340 */       RuntimeTypeInfoSet r = (RuntimeTypeInfoSet)this.typeInfoSetCache.get();
/* 341 */       if (r != null) {
/* 342 */         return r;
/*     */       }
/*     */     }
/* 345 */     RuntimeModelBuilder builder = new RuntimeModelBuilder(new RuntimeInlineAnnotationReader(), this.defaultNsUri);
/*     */     
/*     */ 
/* 348 */     IllegalAnnotationsException.Builder errorHandler = new IllegalAnnotationsException.Builder();
/* 349 */     builder.setErrorHandler(errorHandler);
/*     */     
/* 351 */     for (Class c : this.classes) {
/* 352 */       if (c != CompositeStructure.class)
/*     */       {
/*     */ 
/*     */ 
/* 356 */         builder.getTypeInfo(new Ref(c));
/*     */       }
/*     */     }
/* 359 */     RuntimeTypeInfoSet r = builder.link();
/*     */     
/* 361 */     errorHandler.check();
/* 362 */     assert (r != null) : "if no error was reported, the link must be a success";
/*     */     
/* 364 */     this.typeInfoSetCache = new WeakReference(r);
/*     */     
/* 366 */     return r;
/*     */   }
/*     */   
/*     */   public ElementBeanInfoImpl getElement(Class scope, QName name)
/*     */   {
/* 371 */     Map<QName, ElementBeanInfoImpl> m = (Map)this.elements.get(scope);
/* 372 */     if (m != null) {
/* 373 */       ElementBeanInfoImpl bi = (ElementBeanInfoImpl)m.get(name);
/* 374 */       if (bi != null)
/* 375 */         return bi;
/*     */     }
/* 377 */     m = (Map)this.elements.get(null);
/* 378 */     return (ElementBeanInfoImpl)m.get(name);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private ElementBeanInfoImpl getOrCreate(RuntimeElementInfo rei)
/*     */   {
/* 386 */     JaxBeanInfo bi = (JaxBeanInfo)this.beanInfos.get(rei);
/* 387 */     if (bi != null) { return (ElementBeanInfoImpl)bi;
/*     */     }
/*     */     
/* 390 */     return new ElementBeanInfoImpl(this, rei);
/*     */   }
/*     */   
/*     */   protected JaxBeanInfo getOrCreate(RuntimeEnumLeafInfo eli) {
/* 394 */     JaxBeanInfo bi = (JaxBeanInfo)this.beanInfos.get(eli);
/* 395 */     if (bi != null) return bi;
/* 396 */     bi = new LeafBeanInfoImpl(this, eli);
/* 397 */     this.beanInfoMap.put(bi.jaxbType, bi);
/* 398 */     return bi;
/*     */   }
/*     */   
/*     */   protected ClassBeanInfoImpl getOrCreate(RuntimeClassInfo ci) {
/* 402 */     ClassBeanInfoImpl bi = (ClassBeanInfoImpl)this.beanInfos.get(ci);
/* 403 */     if (bi != null) return bi;
/* 404 */     bi = new ClassBeanInfoImpl(this, ci);
/* 405 */     this.beanInfoMap.put(bi.jaxbType, bi);
/* 406 */     return bi;
/*     */   }
/*     */   
/*     */   protected JaxBeanInfo getOrCreate(RuntimeArrayInfo ai) {
/* 410 */     JaxBeanInfo abi = (JaxBeanInfo)this.beanInfos.get(ai.getType());
/* 411 */     if (abi != null) { return abi;
/*     */     }
/* 413 */     abi = new ArrayBeanInfoImpl(this, ai);
/*     */     
/* 415 */     this.beanInfoMap.put(ai.getType(), abi);
/* 416 */     return abi;
/*     */   }
/*     */   
/*     */   public JaxBeanInfo getOrCreate(RuntimeTypeInfo e) {
/* 420 */     if ((e instanceof RuntimeElementInfo))
/* 421 */       return getOrCreate((RuntimeElementInfo)e);
/* 422 */     if ((e instanceof RuntimeClassInfo))
/* 423 */       return getOrCreate((RuntimeClassInfo)e);
/* 424 */     if ((e instanceof RuntimeLeafInfo)) {
/* 425 */       JaxBeanInfo bi = (JaxBeanInfo)this.beanInfos.get(e);
/* 426 */       assert (bi != null);
/* 427 */       return bi;
/*     */     }
/* 429 */     if ((e instanceof RuntimeArrayInfo))
/* 430 */       return getOrCreate((RuntimeArrayInfo)e);
/* 431 */     if (e.getType() == Object.class)
/*     */     {
/* 433 */       JaxBeanInfo bi = (JaxBeanInfo)this.beanInfoMap.get(Object.class);
/* 434 */       if (bi == null) {
/* 435 */         bi = new AnyTypeBeanInfo(this, e);
/* 436 */         this.beanInfoMap.put(Object.class, bi);
/*     */       }
/* 438 */       return bi;
/*     */     }
/*     */     
/* 441 */     throw new IllegalArgumentException();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final JaxBeanInfo getBeanInfo(Object o)
/*     */   {
/* 456 */     for (Class c = o.getClass(); c != Object.class; c = c.getSuperclass()) {
/* 457 */       JaxBeanInfo bi = (JaxBeanInfo)this.beanInfoMap.get(c);
/* 458 */       if (bi != null) return bi;
/*     */     }
/* 460 */     if ((o instanceof org.w3c.dom.Element))
/* 461 */       return (JaxBeanInfo)this.beanInfoMap.get(Object.class);
/* 462 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final JaxBeanInfo getBeanInfo(Object o, boolean fatal)
/*     */     throws JAXBException
/*     */   {
/* 474 */     JaxBeanInfo bi = getBeanInfo(o);
/* 475 */     if (bi != null) return bi;
/* 476 */     if (fatal)
/* 477 */       throw new JAXBException(o.getClass().getName() + " nor any of its super class is known to this context");
/* 478 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final <T> JaxBeanInfo<T> getBeanInfo(Class<T> clazz)
/*     */   {
/* 492 */     return (JaxBeanInfo)this.beanInfoMap.get(clazz);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final <T> JaxBeanInfo<T> getBeanInfo(Class<T> clazz, boolean fatal)
/*     */     throws JAXBException
/*     */   {
/* 504 */     JaxBeanInfo<T> bi = getBeanInfo(clazz);
/* 505 */     if (bi != null) return bi;
/* 506 */     if (fatal)
/* 507 */       throw new JAXBException(clazz.getName() + " is not known to this context");
/* 508 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Loader selectRootLoader(UnmarshallingContext.State state, TagName ea)
/*     */   {
/* 519 */     JaxBeanInfo beanInfo = (JaxBeanInfo)this.rootMap.get(ea.uri, ea.local);
/* 520 */     if (beanInfo == null)
/*     */     {
/* 522 */       return null;
/*     */     }
/* 524 */     return beanInfo.getLoader(this, true);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JaxBeanInfo getGlobalType(QName name)
/*     */   {
/* 536 */     return (JaxBeanInfo)this.typeMap.get(name);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getNearestTypeName(QName name)
/*     */   {
/* 547 */     String[] all = new String[this.typeMap.size()];
/* 548 */     int i = 0;
/* 549 */     for (QName qn : this.typeMap.keySet()) {
/* 550 */       if (qn.getLocalPart().equals(name.getLocalPart()))
/* 551 */         return qn.toString();
/* 552 */       all[(i++)] = qn.toString();
/*     */     }
/*     */     
/* 555 */     String nearest = EditDistance.findNearest(name.toString(), all);
/*     */     
/* 557 */     if (EditDistance.editDistance(nearest, name.toString()) > 10) {
/* 558 */       return null;
/*     */     }
/* 560 */     return nearest;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Set<QName> getValidRootNames()
/*     */   {
/* 568 */     Set<QName> r = new TreeSet(QNAME_COMPARATOR);
/* 569 */     for (QNameMap.Entry e : this.rootMap.entrySet()) {
/* 570 */       r.add(e.createQName());
/*     */     }
/* 572 */     return r;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public synchronized Encoded[] getUTF8NameTable()
/*     */   {
/* 581 */     if (this.utf8nameTable == null) {
/* 582 */       Encoded[] x = new Encoded[this.nameList.localNames.length];
/* 583 */       for (int i = 0; i < x.length; i++) {
/* 584 */         Encoded e = new Encoded(this.nameList.localNames[i]);
/* 585 */         e.compact();
/* 586 */         x[i] = e;
/*     */       }
/* 588 */       this.utf8nameTable = x;
/*     */     }
/* 590 */     return this.utf8nameTable;
/*     */   }
/*     */   
/*     */   public int getNumberOfLocalNames() {
/* 594 */     return this.nameList.localNames.length;
/*     */   }
/*     */   
/*     */   public int getNumberOfElementNames() {
/* 598 */     return this.nameList.numberOfElementNames;
/*     */   }
/*     */   
/*     */   public int getNumberOfAttributeNames() {
/* 602 */     return this.nameList.numberOfAttributeNames;
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   static javax.xml.transform.Transformer createTransformer()
/*     */   {
/*     */     // Byte code:
/*     */     //   0: ldc_w 192
/*     */     //   3: dup
/*     */     //   4: astore_0
/*     */     //   5: monitorenter
/*     */     //   6: getstatic 193	com/sun/xml/bind/v2/runtime/JAXBContextImpl:tf	Ljavax/xml/transform/sax/SAXTransformerFactory;
/*     */     //   9: ifnonnull +12 -> 21
/*     */     //   12: invokestatic 194	javax/xml/transform/TransformerFactory:newInstance	()Ljavax/xml/transform/TransformerFactory;
/*     */     //   15: checkcast 195	javax/xml/transform/sax/SAXTransformerFactory
/*     */     //   18: putstatic 193	com/sun/xml/bind/v2/runtime/JAXBContextImpl:tf	Ljavax/xml/transform/sax/SAXTransformerFactory;
/*     */     //   21: getstatic 193	com/sun/xml/bind/v2/runtime/JAXBContextImpl:tf	Ljavax/xml/transform/sax/SAXTransformerFactory;
/*     */     //   24: invokevirtual 196	javax/xml/transform/sax/SAXTransformerFactory:newTransformer	()Ljavax/xml/transform/Transformer;
/*     */     //   27: aload_0
/*     */     //   28: monitorexit
/*     */     //   29: areturn
/*     */     //   30: astore_1
/*     */     //   31: aload_0
/*     */     //   32: monitorexit
/*     */     //   33: aload_1
/*     */     //   34: athrow
/*     */     //   35: astore_0
/*     */     //   36: new 198	java/lang/Error
/*     */     //   39: dup
/*     */     //   40: aload_0
/*     */     //   41: invokespecial 199	java/lang/Error:<init>	(Ljava/lang/Throwable;)V
/*     */     //   44: athrow
/*     */     // Line number table:
/*     */     //   Java source line #610	-> byte code offset #0
/*     */     //   Java source line #611	-> byte code offset #6
/*     */     //   Java source line #612	-> byte code offset #12
/*     */     //   Java source line #613	-> byte code offset #21
/*     */     //   Java source line #614	-> byte code offset #30
/*     */     //   Java source line #615	-> byte code offset #35
/*     */     //   Java source line #616	-> byte code offset #36
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   35	6	0	e	javax.xml.transform.TransformerConfigurationException
/*     */     //   30	4	1	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   6	29	30	finally
/*     */     //   30	33	30	finally
/*     */     //   0	29	35	javax/xml/transform/TransformerConfigurationException
/*     */     //   30	35	35	javax/xml/transform/TransformerConfigurationException
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public static javax.xml.transform.sax.TransformerHandler createTransformerHandler()
/*     */   {
/*     */     // Byte code:
/*     */     //   0: ldc_w 192
/*     */     //   3: dup
/*     */     //   4: astore_0
/*     */     //   5: monitorenter
/*     */     //   6: getstatic 193	com/sun/xml/bind/v2/runtime/JAXBContextImpl:tf	Ljavax/xml/transform/sax/SAXTransformerFactory;
/*     */     //   9: ifnonnull +12 -> 21
/*     */     //   12: invokestatic 194	javax/xml/transform/TransformerFactory:newInstance	()Ljavax/xml/transform/TransformerFactory;
/*     */     //   15: checkcast 195	javax/xml/transform/sax/SAXTransformerFactory
/*     */     //   18: putstatic 193	com/sun/xml/bind/v2/runtime/JAXBContextImpl:tf	Ljavax/xml/transform/sax/SAXTransformerFactory;
/*     */     //   21: getstatic 193	com/sun/xml/bind/v2/runtime/JAXBContextImpl:tf	Ljavax/xml/transform/sax/SAXTransformerFactory;
/*     */     //   24: invokevirtual 200	javax/xml/transform/sax/SAXTransformerFactory:newTransformerHandler	()Ljavax/xml/transform/sax/TransformerHandler;
/*     */     //   27: aload_0
/*     */     //   28: monitorexit
/*     */     //   29: areturn
/*     */     //   30: astore_1
/*     */     //   31: aload_0
/*     */     //   32: monitorexit
/*     */     //   33: aload_1
/*     */     //   34: athrow
/*     */     //   35: astore_0
/*     */     //   36: new 198	java/lang/Error
/*     */     //   39: dup
/*     */     //   40: aload_0
/*     */     //   41: invokespecial 199	java/lang/Error:<init>	(Ljava/lang/Throwable;)V
/*     */     //   44: athrow
/*     */     // Line number table:
/*     */     //   Java source line #625	-> byte code offset #0
/*     */     //   Java source line #626	-> byte code offset #6
/*     */     //   Java source line #627	-> byte code offset #12
/*     */     //   Java source line #628	-> byte code offset #21
/*     */     //   Java source line #629	-> byte code offset #30
/*     */     //   Java source line #630	-> byte code offset #35
/*     */     //   Java source line #631	-> byte code offset #36
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   35	6	0	e	javax.xml.transform.TransformerConfigurationException
/*     */     //   30	4	1	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   6	29	30	finally
/*     */     //   30	33	30	finally
/*     */     //   0	29	35	javax/xml/transform/TransformerConfigurationException
/*     */     //   30	35	35	javax/xml/transform/TransformerConfigurationException
/*     */   }
/*     */   
/*     */   static Document createDom()
/*     */   {
/* 639 */     synchronized (JAXBContextImpl.class) {
/* 640 */       if (db == null) {
/*     */         try {
/* 642 */           DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
/* 643 */           dbf.setNamespaceAware(true);
/* 644 */           db = dbf.newDocumentBuilder();
/*     */         }
/*     */         catch (ParserConfigurationException e) {
/* 647 */           throw new FactoryConfigurationError(e);
/*     */         }
/*     */       }
/* 650 */       return db.newDocument();
/*     */     }
/*     */   }
/*     */   
/*     */   public MarshallerImpl createMarshaller() {
/* 655 */     return new MarshallerImpl(this, null);
/*     */   }
/*     */   
/*     */   public UnmarshallerImpl createUnmarshaller() {
/* 659 */     return new UnmarshallerImpl(this, null);
/*     */   }
/*     */   
/*     */   public Validator createValidator() {
/* 663 */     throw new UnsupportedOperationException(Messages.NOT_IMPLEMENTED_IN_2_0.format(new Object[0]));
/*     */   }
/*     */   
/*     */   public JAXBIntrospector createJAXBIntrospector()
/*     */   {
/* 668 */     new JAXBIntrospector() {
/*     */       public boolean isElement(Object object) {
/* 670 */         return getElementName(object) != null;
/*     */       }
/*     */       
/*     */       public QName getElementName(Object jaxbElement) {
/*     */         try {
/* 675 */           return JAXBContextImpl.this.getElementName(jaxbElement);
/*     */         } catch (JAXBException e) {}
/* 677 */         return null;
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   private NonElement<Type, Class> getXmlType(RuntimeTypeInfoSet tis, TypeReference tr)
/*     */   {
/* 684 */     if (tr == null) {
/* 685 */       throw new IllegalArgumentException();
/*     */     }
/* 687 */     XmlJavaTypeAdapter xjta = (XmlJavaTypeAdapter)tr.get(XmlJavaTypeAdapter.class);
/* 688 */     XmlList xl = (XmlList)tr.get(XmlList.class);
/*     */     
/* 690 */     Ref<Type, Class> ref = new Ref(new RuntimeInlineAnnotationReader(), tis.getNavigator(), tr.type, xjta, xl);
/*     */     
/*     */ 
/* 693 */     return tis.getTypeInfo(ref);
/*     */   }
/*     */   
/*     */   public void generateSchema(SchemaOutputResolver outputResolver) throws IOException {
/* 697 */     if (outputResolver == null) {
/* 698 */       throw new IOException(Messages.NULL_OUTPUT_RESOLVER.format(new Object[0]));
/*     */     }
/*     */     RuntimeTypeInfoSet tis;
/*     */     try
/*     */     {
/* 703 */       tis = getTypeInfoSet();
/*     */     }
/*     */     catch (IllegalAnnotationsException e) {
/* 706 */       throw new AssertionError(e);
/*     */     }
/*     */     
/* 709 */     XmlSchemaGenerator<Type, Class, Field, Method> xsdgen = new XmlSchemaGenerator(tis.getNavigator(), tis);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 715 */     Set<QName> rootTagNames = new HashSet();
/* 716 */     for (RuntimeElementInfo ei : tis.getAllElements()) {
/* 717 */       rootTagNames.add(ei.getElementName());
/*     */     }
/* 719 */     for (RuntimeClassInfo ci : tis.beans().values()) {
/* 720 */       if (ci.isElement()) {
/* 721 */         rootTagNames.add(ci.asElement().getElementName());
/*     */       }
/*     */     }
/* 724 */     for (TypeReference tr : this.bridges.keySet()) {
/* 725 */       if (!rootTagNames.contains(tr.tagName))
/*     */       {
/*     */ 
/* 728 */         if ((tr.type == Void.TYPE) || (tr.type == Void.class)) {
/* 729 */           xsdgen.add(tr.tagName, false, null);
/*     */         } else {
/* 731 */           NonElement<Type, Class> typeInfo = getXmlType(tis, tr);
/* 732 */           xsdgen.add(tr.tagName, !Navigator.REFLECTION.isPrimitive(tr.type), typeInfo);
/*     */         }
/*     */       }
/*     */     }
/* 736 */     xsdgen.write(outputResolver);
/*     */   }
/*     */   
/*     */   public QName getTypeName(TypeReference tr) {
/*     */     try {
/* 741 */       NonElement<Type, Class> xt = getXmlType(getTypeInfoSet(), tr);
/* 742 */       if (xt == null) throw new IllegalArgumentException();
/* 743 */       return xt.getTypeName();
/*     */     }
/*     */     catch (IllegalAnnotationsException e) {
/* 746 */       throw new AssertionError(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public SchemaOutputResolver createTestResolver()
/*     */   {
/* 754 */     new SchemaOutputResolver() {
/*     */       public Result createOutput(String namespaceUri, String suggestedFileName) {
/* 756 */         SAXResult r = new SAXResult(new DefaultHandler());
/* 757 */         r.setSystemId(suggestedFileName);
/* 758 */         return r;
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   public <T> Binder<T> createBinder(Class<T> domType)
/*     */   {
/* 765 */     if (domType == Node.class) {
/* 766 */       return createBinder();
/*     */     }
/* 768 */     return super.createBinder(domType);
/*     */   }
/*     */   
/*     */   public Binder<Node> createBinder()
/*     */   {
/* 773 */     return new BinderImpl(this, new DOMScanner());
/*     */   }
/*     */   
/*     */   public QName getElementName(Object o) throws JAXBException {
/* 777 */     JaxBeanInfo bi = getBeanInfo(o, true);
/* 778 */     if (!bi.isElement())
/* 779 */       return null;
/* 780 */     return new QName(bi.getElementNamespaceURI(o), bi.getElementLocalName(o));
/*     */   }
/*     */   
/*     */   public Bridge createBridge(TypeReference ref) {
/* 784 */     return (Bridge)this.bridges.get(ref);
/*     */   }
/*     */   
/*     */   @NotNull
/* 788 */   public BridgeContext createBridgeContext() { return new BridgeContextImpl(this); }
/*     */   
/*     */   public RawAccessor getElementPropertyAccessor(Class wrapperBean, String nsUri, String localName) throws JAXBException
/*     */   {
/* 792 */     JaxBeanInfo bi = getBeanInfo(wrapperBean, true);
/* 793 */     if (!(bi instanceof ClassBeanInfoImpl)) {
/* 794 */       throw new JAXBException(wrapperBean + " is not a bean");
/*     */     }
/* 796 */     for (ClassBeanInfoImpl cb = (ClassBeanInfoImpl)bi; cb != null; cb = cb.superClazz) {
/* 797 */       for (Property p : cb.properties) {
/* 798 */         final Accessor acc = p.getElementPropertyAccessor(nsUri, localName);
/* 799 */         if (acc != null)
/* 800 */           new RawAccessor()
/*     */           {
/*     */ 
/*     */             public Object get(Object bean)
/*     */               throws AccessorException
/*     */             {
/*     */ 
/* 807 */               return acc.getUnadapted(bean);
/*     */             }
/*     */             
/*     */             public void set(Object bean, Object value) throws AccessorException {
/* 811 */               acc.setUnadapted(bean, value);
/*     */             }
/*     */           };
/*     */       }
/*     */     }
/* 816 */     throw new JAXBException(new QName(nsUri, localName) + " is not a valid property on " + wrapperBean);
/*     */   }
/*     */   
/*     */   public List<String> getKnownNamespaceURIs() {
/* 820 */     return Arrays.asList(this.nameList.namespaceURIs);
/*     */   }
/*     */   
/*     */   public String getBuildId() {
/* 824 */     Package pkg = getClass().getPackage();
/* 825 */     if (pkg == null) return null;
/* 826 */     return pkg.getImplementationVersion();
/*     */   }
/*     */   
/*     */   public String toString() {
/* 830 */     StringBuilder buf = new StringBuilder(Which.which(getClass()) + " Build-Id: " + getBuildId());
/* 831 */     buf.append("\nClasses known to this context:\n");
/*     */     
/* 833 */     Set<String> names = new TreeSet();
/*     */     
/* 835 */     for (Class key : this.beanInfoMap.keySet()) {
/* 836 */       names.add(key.getName());
/*     */     }
/* 838 */     for (String name : names) {
/* 839 */       buf.append("  ").append(name).append('\n');
/*     */     }
/* 841 */     return buf.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getXMIMEContentType(Object o)
/*     */   {
/* 849 */     JaxBeanInfo bi = getBeanInfo(o);
/* 850 */     if (!(bi instanceof ClassBeanInfoImpl)) {
/* 851 */       return null;
/*     */     }
/* 853 */     ClassBeanInfoImpl cb = (ClassBeanInfoImpl)bi;
/* 854 */     for (Property p : cb.properties) {
/* 855 */       if ((p instanceof AttributeProperty)) {
/* 856 */         AttributeProperty ap = (AttributeProperty)p;
/* 857 */         if (ap.attName.equals("http://www.w3.org/2005/05/xmlmime", "contentType"))
/*     */           try {
/* 859 */             return (String)ap.xacc.print(o);
/*     */           } catch (AccessorException e) {
/* 861 */             return null;
/*     */           } catch (SAXException e) {
/* 863 */             return null;
/*     */           } catch (ClassCastException e) {
/* 865 */             return null;
/*     */           }
/*     */       }
/*     */     }
/* 869 */     return null;
/*     */   }
/*     */   
/* 872 */   private static final Comparator<QName> QNAME_COMPARATOR = new Comparator() {
/*     */     public int compare(QName lhs, QName rhs) {
/* 874 */       int r = lhs.getLocalPart().compareTo(rhs.getLocalPart());
/* 875 */       if (r != 0) { return r;
/*     */       }
/* 877 */       return lhs.getNamespaceURI().compareTo(rhs.getNamespaceURI());
/*     */     }
/*     */   };
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\JAXBContextImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */