/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.istack.FinalArrayList;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import java.util.Arrays;
/*     */ import java.util.Collections;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class C14nXmlOutput
/*     */   extends UTF8XmlOutput
/*     */ {
/*     */   public C14nXmlOutput(OutputStream out, Encoded[] localNames, boolean namedAttributesAreOrdered)
/*     */   {
/*  20 */     super(out, localNames);
/*  21 */     this.namedAttributesAreOrdered = namedAttributesAreOrdered;
/*     */     
/*  23 */     for (int i = 0; i < this.staticAttributes.length; i++) {
/*  24 */       this.staticAttributes[i] = new StaticAttribute();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  32 */   private StaticAttribute[] staticAttributes = new StaticAttribute[8];
/*  33 */   private int len = 0;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  38 */   private int[] nsBuf = new int[8];
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  47 */   private final FinalArrayList<DynamicAttribute> otherAttributes = new FinalArrayList();
/*     */   
/*     */   private final boolean namedAttributesAreOrdered;
/*     */   
/*     */   final class StaticAttribute
/*     */     implements Comparable<StaticAttribute>
/*     */   {
/*     */     Name name;
/*     */     String value;
/*     */     
/*     */     StaticAttribute() {}
/*     */     
/*     */     public void set(Name name, String value)
/*     */     {
/*  61 */       this.name = name;
/*  62 */       this.value = value;
/*     */     }
/*     */     
/*     */     void write() throws IOException {
/*  66 */       C14nXmlOutput.this.attribute(this.name, this.value);
/*     */     }
/*     */     
/*     */     C14nXmlOutput.DynamicAttribute toDynamicAttribute() {
/*  70 */       int nsUriIndex = this.name.nsUriIndex;
/*     */       int prefix;
/*  72 */       int prefix; if (nsUriIndex == -1) {
/*  73 */         prefix = -1;
/*     */       } else
/*  75 */         prefix = C14nXmlOutput.this.nsUriIndex2prefixIndex[nsUriIndex];
/*  76 */       return new C14nXmlOutput.DynamicAttribute(C14nXmlOutput.this, prefix, this.name.localName, this.value);
/*     */     }
/*     */     
/*     */     public int compareTo(StaticAttribute that)
/*     */     {
/*  81 */       return this.name.compareTo(that.name);
/*     */     }
/*     */   }
/*     */   
/*     */   final class DynamicAttribute implements Comparable<DynamicAttribute>
/*     */   {
/*     */     final int prefix;
/*     */     final String localName;
/*     */     final String value;
/*     */     
/*     */     public DynamicAttribute(int prefix, String localName, String value) {
/*  92 */       this.prefix = prefix;
/*  93 */       this.localName = localName;
/*  94 */       this.value = value;
/*     */     }
/*     */     
/*     */     private String getURI() {
/*  98 */       if (this.prefix == -1) return "";
/*  99 */       return C14nXmlOutput.this.nsContext.getNamespaceURI(this.prefix);
/*     */     }
/*     */     
/*     */     public int compareTo(DynamicAttribute that) {
/* 103 */       int r = getURI().compareTo(that.getURI());
/* 104 */       if (r != 0) return r;
/* 105 */       return this.localName.compareTo(that.localName);
/*     */     }
/*     */   }
/*     */   
/*     */   public void attribute(Name name, String value) throws IOException
/*     */   {
/* 111 */     if (this.staticAttributes.length == this.len)
/*     */     {
/* 113 */       int newLen = this.len * 2;
/* 114 */       StaticAttribute[] newbuf = new StaticAttribute[newLen];
/* 115 */       System.arraycopy(this.staticAttributes, 0, newbuf, 0, this.len);
/* 116 */       for (int i = this.len; i < newLen; i++)
/* 117 */         this.staticAttributes[i] = new StaticAttribute();
/* 118 */       this.staticAttributes = newbuf;
/*     */     }
/*     */     
/* 121 */     this.staticAttributes[(this.len++)].set(name, value);
/*     */   }
/*     */   
/*     */   public void attribute(int prefix, String localName, String value) throws IOException
/*     */   {
/* 126 */     this.otherAttributes.add(new DynamicAttribute(prefix, localName, value));
/*     */   }
/*     */   
/*     */   public void endStartTag() throws IOException
/*     */   {
/* 131 */     if (this.otherAttributes.isEmpty()) {
/* 132 */       if (this.len != 0)
/*     */       {
/*     */ 
/* 135 */         if (!this.namedAttributesAreOrdered) {
/* 136 */           Arrays.sort(this.staticAttributes, 0, this.len);
/*     */         }
/* 138 */         for (int i = 0; i < this.len; i++)
/* 139 */           this.staticAttributes[i].write();
/* 140 */         this.len = 0;
/*     */       }
/*     */       
/*     */     }
/*     */     else
/*     */     {
/* 146 */       for (int i = 0; i < this.len; i++)
/* 147 */         this.otherAttributes.add(this.staticAttributes[i].toDynamicAttribute());
/* 148 */       this.len = 0;
/* 149 */       Collections.sort(this.otherAttributes);
/*     */       
/*     */ 
/* 152 */       int size = this.otherAttributes.size();
/* 153 */       for (int i = 0; i < size; i++) {
/* 154 */         DynamicAttribute a = (DynamicAttribute)this.otherAttributes.get(i);
/* 155 */         super.attribute(a.prefix, a.localName, a.value);
/*     */       }
/* 157 */       this.otherAttributes.clear();
/*     */     }
/* 159 */     super.endStartTag();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected void writeNsDecls(int base)
/*     */     throws IOException
/*     */   {
/* 167 */     int count = this.nsContext.getCurrent().count();
/*     */     
/* 169 */     if (count == 0) {
/* 170 */       return;
/*     */     }
/* 172 */     if (count > this.nsBuf.length) {
/* 173 */       this.nsBuf = new int[count];
/*     */     }
/* 175 */     for (int i = count - 1; i >= 0; i--) {
/* 176 */       this.nsBuf[i] = (base + i);
/*     */     }
/*     */     
/*     */ 
/* 180 */     for (int i = 0; i < count; i++) {
/* 181 */       for (int j = i + 1; j < count; j++) {
/* 182 */         String p = this.nsContext.getPrefix(this.nsBuf[i]);
/* 183 */         String q = this.nsContext.getPrefix(this.nsBuf[j]);
/* 184 */         if (p.compareTo(q) > 0)
/*     */         {
/* 186 */           int t = this.nsBuf[j];
/* 187 */           this.nsBuf[j] = this.nsBuf[i];
/* 188 */           this.nsBuf[i] = t;
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 194 */     for (int i = 0; i < count; i++) {
/* 195 */       writeNsDecl(this.nsBuf[i]);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\C14nXmlOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */