/*     */ package com.sun.xml.bind.v2.runtime.property;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.NameBuilder;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Receiver;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Scope;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.TagName;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import java.io.IOException;
/*     */ import java.util.Collection;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ abstract class ArrayERProperty<BeanT, ListT, ItemT>
/*     */   extends ArrayProperty<BeanT, ListT, ItemT>
/*     */ {
/*     */   protected final Name wrapperTagName;
/*     */   protected final boolean isWrapperNillable;
/*     */   
/*     */   protected ArrayERProperty(JAXBContextImpl grammar, RuntimePropertyInfo prop, QName tagName, boolean isWrapperNillable)
/*     */   {
/*  45 */     super(grammar, prop);
/*  46 */     if (tagName == null) {
/*  47 */       this.wrapperTagName = null;
/*     */     } else
/*  49 */       this.wrapperTagName = grammar.nameBuilder.createElementName(tagName);
/*  50 */     this.isWrapperNillable = isWrapperNillable;
/*     */   }
/*     */   
/*     */   private static final class ItemsLoader extends Loader {
/*     */     private final QNameMap<ChildLoader> children;
/*     */     
/*  56 */     public ItemsLoader(QNameMap<ChildLoader> children) { super();
/*  57 */       this.children = children;
/*     */     }
/*     */     
/*     */     public void startElement(UnmarshallingContext.State state, TagName ea)
/*     */     {
/*  62 */       state.getContext().startScope(1);
/*     */       
/*  64 */       state.target = state.prev.target;
/*     */     }
/*     */     
/*     */ 
/*     */     public void childElement(UnmarshallingContext.State state, TagName ea)
/*     */       throws SAXException
/*     */     {
/*  71 */       ChildLoader child = (ChildLoader)this.children.get(ea.uri, ea.local);
/*  72 */       if (child != null) {
/*  73 */         state.loader = child.loader;
/*  74 */         state.receiver = child.receiver;
/*     */       } else {
/*  76 */         super.childElement(state, ea);
/*     */       }
/*     */     }
/*     */     
/*     */     public void leaveElement(UnmarshallingContext.State state, TagName ea) throws SAXException
/*     */     {
/*  82 */       state.getContext().endScope(1);
/*     */     }
/*     */     
/*     */     public Collection<QName> getExpectedChildElements()
/*     */     {
/*  87 */       return this.children.keySet();
/*     */     }
/*     */   }
/*     */   
/*     */   public final void serializeBody(BeanT o, XMLSerializer w, Object outerPeer) throws SAXException, AccessorException, IOException, XMLStreamException {
/*  92 */     ListT list = this.acc.get(o);
/*     */     
/*  94 */     if (list != null) {
/*  95 */       if (this.wrapperTagName != null) {
/*  96 */         w.startElement(this.wrapperTagName, null);
/*  97 */         w.endNamespaceDecls(list);
/*  98 */         w.endAttributes();
/*     */       }
/*     */       
/* 101 */       serializeListBody(o, w, list);
/*     */       
/* 103 */       if (this.wrapperTagName != null) {
/* 104 */         w.endElement();
/*     */       }
/*     */     }
/* 107 */     else if (this.isWrapperNillable) {
/* 108 */       w.startElement(this.wrapperTagName, null);
/* 109 */       w.writeXsiNilTrue();
/* 110 */       w.endElement();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected abstract void serializeListBody(BeanT paramBeanT, XMLSerializer paramXMLSerializer, ListT paramListT)
/*     */     throws IOException, XMLStreamException, SAXException, AccessorException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected abstract void createBodyUnmarshaller(UnmarshallerChain paramUnmarshallerChain, QNameMap<ChildLoader> paramQNameMap);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void buildChildElementUnmarshallers(UnmarshallerChain chain, QNameMap<ChildLoader> loaders)
/*     */   {
/* 131 */     if (this.wrapperTagName != null) {
/* 132 */       UnmarshallerChain c = new UnmarshallerChain(chain.context);
/* 133 */       QNameMap<ChildLoader> m = new QNameMap();
/* 134 */       createBodyUnmarshaller(c, m);
/* 135 */       loaders.put(this.wrapperTagName, new ChildLoader(new ItemsLoader(m), null));
/*     */     } else {
/* 137 */       createBodyUnmarshaller(chain, loaders);
/*     */     }
/*     */   }
/*     */   
/*     */   protected final class ReceiverImpl
/*     */     implements Receiver
/*     */   {
/*     */     private final int offset;
/*     */     
/*     */     protected ReceiverImpl(int offset)
/*     */     {
/* 148 */       this.offset = offset;
/*     */     }
/*     */     
/*     */     public void receive(UnmarshallingContext.State state, Object o) throws SAXException {
/* 152 */       state.getContext().getScope(this.offset).add(ArrayERProperty.this.acc, ArrayERProperty.this.lister, o);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\ArrayERProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */