/*     */ package com.sun.xml.bind.v2.runtime.reflect;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.istack.Nullable;
/*     */ import com.sun.istack.SAXException2;
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.impl.RuntimeModelBuilder;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeNonElementRef;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.Transducer;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.opt.OptimizedTransducedAccessorFactory;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Patcher;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import java.io.IOException;
/*     */ import java.util.concurrent.Callable;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class TransducedAccessor<BeanT>
/*     */ {
/*     */   public boolean useNamespace()
/*     */   {
/*  51 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void declareNamespace(BeanT o, XMLSerializer w)
/*     */     throws AccessorException, SAXException
/*     */   {}
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Nullable
/*     */   public abstract CharSequence print(@NotNull BeanT paramBeanT)
/*     */     throws AccessorException, SAXException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void parse(BeanT paramBeanT, CharSequence paramCharSequence)
/*     */     throws AccessorException, SAXException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract boolean hasValue(BeanT paramBeanT)
/*     */     throws AccessorException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static <T> TransducedAccessor<T> get(RuntimeNonElementRef ref)
/*     */   {
/* 115 */     Transducer xducer = RuntimeModelBuilder.createTransducer(ref);
/* 116 */     RuntimePropertyInfo prop = ref.getSource();
/*     */     
/* 118 */     if (prop.isCollection()) {
/* 119 */       return new ListTransducedAccessorImpl(xducer, prop.getAccessor(), Lister.create(Navigator.REFLECTION.erasure(prop.getRawType()), prop.id(), prop.getAdapter()));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 124 */     if (prop.id() == ID.IDREF) {
/* 125 */       return new IDREFTransducedAccessorImpl(prop.getAccessor());
/*     */     }
/* 127 */     if (xducer.isDefault()) {
/* 128 */       TransducedAccessor xa = OptimizedTransducedAccessorFactory.get(prop);
/* 129 */       if (xa != null) { return xa;
/*     */       }
/*     */     }
/* 132 */     if (xducer.useNamespace()) {
/* 133 */       return new CompositeContextDependentTransducedAccessorImpl(xducer, prop.getAccessor());
/*     */     }
/* 135 */     return new CompositeTransducedAccessorImpl(xducer, prop.getAccessor());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void writeLeafElement(XMLSerializer paramXMLSerializer, Name paramName, BeanT paramBeanT, String paramString)
/*     */     throws SAXException, AccessorException, IOException, XMLStreamException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void writeText(XMLSerializer paramXMLSerializer, BeanT paramBeanT, String paramString)
/*     */     throws AccessorException, SAXException, IOException, XMLStreamException;
/*     */   
/*     */ 
/*     */ 
/*     */   static class CompositeContextDependentTransducedAccessorImpl<BeanT, ValueT>
/*     */     extends TransducedAccessor.CompositeTransducedAccessorImpl<BeanT, ValueT>
/*     */   {
/*     */     public CompositeContextDependentTransducedAccessorImpl(Transducer<ValueT> xducer, Accessor<BeanT, ValueT> acc)
/*     */     {
/* 157 */       super(acc);
/* 158 */       assert (xducer.useNamespace());
/*     */     }
/*     */     
/*     */     public boolean useNamespace() {
/* 162 */       return true;
/*     */     }
/*     */     
/*     */     public void declareNamespace(BeanT bean, XMLSerializer w) throws AccessorException {
/* 166 */       ValueT o = this.acc.get(bean);
/* 167 */       if (o != null) {
/* 168 */         this.xducer.declareNamespace(o, w);
/*     */       }
/*     */     }
/*     */     
/*     */     public void writeLeafElement(XMLSerializer w, Name tagName, BeanT o, String fieldName) throws SAXException, AccessorException, IOException, XMLStreamException {
/* 173 */       w.startElement(tagName, null);
/* 174 */       declareNamespace(o, w);
/* 175 */       w.endNamespaceDecls(null);
/* 176 */       w.endAttributes();
/* 177 */       this.xducer.writeText(w, this.acc.get(o), fieldName);
/* 178 */       w.endElement();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   static class CompositeTransducedAccessorImpl<BeanT, ValueT>
/*     */     extends TransducedAccessor<BeanT>
/*     */   {
/*     */     protected final Transducer<ValueT> xducer;
/*     */     
/*     */     protected final Accessor<BeanT, ValueT> acc;
/*     */     
/*     */     public CompositeTransducedAccessorImpl(Transducer<ValueT> xducer, Accessor<BeanT, ValueT> acc)
/*     */     {
/* 192 */       this.xducer = xducer;
/* 193 */       this.acc = acc.optimize();
/*     */     }
/*     */     
/*     */     public CharSequence print(BeanT bean) throws AccessorException {
/* 197 */       ValueT o = this.acc.get(bean);
/* 198 */       if (o == null) return null;
/* 199 */       return this.xducer.print(o);
/*     */     }
/*     */     
/*     */     public void parse(BeanT bean, CharSequence lexical) throws AccessorException, SAXException {
/* 203 */       this.acc.set(bean, this.xducer.parse(lexical));
/*     */     }
/*     */     
/*     */     public boolean hasValue(BeanT bean) throws AccessorException {
/* 207 */       return this.acc.getUnadapted(bean) != null;
/*     */     }
/*     */     
/*     */     public void writeLeafElement(XMLSerializer w, Name tagName, BeanT o, String fieldName) throws SAXException, AccessorException, IOException, XMLStreamException
/*     */     {
/* 212 */       this.xducer.writeLeafElement(w, tagName, this.acc.get(o), fieldName);
/*     */     }
/*     */     
/*     */     public void writeText(XMLSerializer w, BeanT o, String fieldName) throws AccessorException, SAXException, IOException, XMLStreamException
/*     */     {
/* 217 */       this.xducer.writeText(w, this.acc.get(o), fieldName);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private static final class IDREFTransducedAccessorImpl<BeanT, TargetT>
/*     */     extends DefaultTransducedAccessor<BeanT>
/*     */   {
/*     */     private final Accessor<BeanT, TargetT> acc;
/*     */     
/*     */ 
/*     */     private final Class<TargetT> targetType;
/*     */     
/*     */ 
/*     */ 
/*     */     public IDREFTransducedAccessorImpl(Accessor<BeanT, TargetT> acc)
/*     */     {
/* 236 */       this.acc = acc;
/* 237 */       this.targetType = acc.getValueType();
/*     */     }
/*     */     
/*     */     public String print(BeanT bean) throws AccessorException, SAXException {
/* 241 */       TargetT target = this.acc.get(bean);
/* 242 */       if (target == null) { return null;
/*     */       }
/* 244 */       XMLSerializer w = XMLSerializer.getInstance();
/*     */       try {
/* 246 */         String id = w.grammar.getBeanInfo(target, true).getId(target, w);
/* 247 */         if (id == null)
/* 248 */           w.errorMissingId(target);
/* 249 */         return id;
/*     */       } catch (JAXBException e) {
/* 251 */         w.reportError(null, e); }
/* 252 */       return null;
/*     */     }
/*     */     
/*     */     private void assign(BeanT bean, TargetT t, UnmarshallingContext context) throws AccessorException
/*     */     {
/* 257 */       if (!this.targetType.isInstance(t)) {
/* 258 */         context.handleError(Messages.UNASSIGNABLE_TYPE.format(new Object[] { this.targetType, t.getClass() }));
/*     */       } else
/* 260 */         this.acc.set(bean, t);
/*     */     }
/*     */     
/*     */     public void parse(final BeanT bean, CharSequence lexical) throws AccessorException, SAXException {
/* 264 */       final String idref = WhiteSpaceProcessor.trim(lexical).toString();
/* 265 */       final UnmarshallingContext context = UnmarshallingContext.getInstance();
/*     */       
/* 267 */       final Callable callable = context.getObjectFromId(idref, this.acc.valueType);
/* 268 */       if (callable == null) {
/* 269 */         context.errorUnresolvedIDREF(bean, idref); return;
/*     */       }
/*     */       
/*     */       TargetT t;
/*     */       try
/*     */       {
/* 275 */         t = callable.call();
/*     */       } catch (SAXException e) {
/* 277 */         throw e;
/*     */       } catch (RuntimeException e) {
/* 279 */         throw e;
/*     */       } catch (Exception e) {
/* 281 */         throw new SAXException2(e);
/*     */       }
/* 283 */       if (t != null) {
/* 284 */         assign(bean, t, context);
/*     */       }
/*     */       else {
/* 287 */         context.addPatcher(new Patcher() {
/*     */           public void run() throws SAXException {
/*     */             try {
/* 290 */               TargetT t = callable.call();
/* 291 */               if (t == null) {
/* 292 */                 context.errorUnresolvedIDREF(bean, idref);
/*     */               } else {
/* 294 */                 TransducedAccessor.IDREFTransducedAccessorImpl.this.assign(bean, t, context);
/*     */               }
/*     */             } catch (AccessorException e) {
/* 297 */               context.handleError(e);
/*     */             } catch (SAXException e) {
/* 299 */               throw e;
/*     */             } catch (RuntimeException e) {
/* 301 */               throw e;
/*     */             } catch (Exception e) {
/* 303 */               throw new SAXException2(e);
/*     */             }
/*     */           }
/*     */         });
/*     */       }
/*     */     }
/*     */     
/*     */     public boolean hasValue(BeanT bean) throws AccessorException {
/* 311 */       return this.acc.get(bean) != null;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\TransducedAccessor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */