/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.istack.Nullable;
/*     */ import com.sun.xml.bind.DatatypeConverterImpl;
/*     */ import com.sun.xml.bind.v2.runtime.output.Pcdata;
/*     */ import com.sun.xml.bind.v2.runtime.output.UTF8XmlOutput;
/*     */ import com.sun.xml.bind.v2.util.ByteArrayOutputStreamEx;
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import javax.activation.DataHandler;
/*     */ import javax.activation.DataSource;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class Base64Data
/*     */   extends Pcdata
/*     */ {
/*     */   private DataHandler dataHandler;
/*     */   private byte[] data;
/*     */   private int dataLen;
/*     */   @Nullable
/*     */   private String mimeType;
/*     */   
/*     */   public void set(byte[] data, int len, @Nullable String mimeType)
/*     */   {
/*  62 */     this.data = data;
/*  63 */     this.dataLen = len;
/*  64 */     this.dataHandler = null;
/*  65 */     this.mimeType = mimeType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void set(byte[] data, @Nullable String mimeType)
/*     */   {
/*  75 */     set(data, data.length, mimeType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void set(DataHandler data)
/*     */   {
/*  82 */     assert (data != null);
/*  83 */     this.dataHandler = data;
/*  84 */     this.data = null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public DataHandler getDataHandler()
/*     */   {
/*  91 */     if (this.dataHandler == null) {
/*  92 */       this.dataHandler = new DataHandler(new DataSource() {
/*     */         public String getContentType() {
/*  94 */           return Base64Data.this.getMimeType();
/*     */         }
/*     */         
/*     */         public InputStream getInputStream() {
/*  98 */           return new ByteArrayInputStream(Base64Data.this.data, 0, Base64Data.this.dataLen);
/*     */         }
/*     */         
/*     */         public String getName() {
/* 102 */           return null;
/*     */         }
/*     */         
/*     */         public OutputStream getOutputStream() {
/* 106 */           throw new UnsupportedOperationException();
/*     */         }
/*     */       });
/*     */     }
/*     */     
/* 111 */     return this.dataHandler;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public byte[] getExact()
/*     */   {
/* 118 */     get();
/* 119 */     if (this.dataLen != this.data.length) {
/* 120 */       byte[] buf = new byte[this.dataLen];
/* 121 */       System.arraycopy(this.data, 0, buf, 0, this.dataLen);
/* 122 */       this.data = buf;
/*     */     }
/* 124 */     return this.data;
/*     */   }
/*     */   
/*     */ 
/*     */   public InputStream getInputStream()
/*     */     throws IOException
/*     */   {
/* 131 */     if (this.dataHandler != null) {
/* 132 */       return this.dataHandler.getInputStream();
/*     */     }
/* 134 */     return new ByteArrayInputStream(this.data, 0, this.dataLen);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean hasData()
/*     */   {
/* 142 */     return this.data != null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public byte[] get()
/*     */   {
/* 149 */     if (this.data == null) {
/*     */       try {
/* 151 */         ByteArrayOutputStreamEx baos = new ByteArrayOutputStreamEx(1024);
/* 152 */         InputStream is = this.dataHandler.getDataSource().getInputStream();
/* 153 */         baos.readFrom(is);
/* 154 */         is.close();
/* 155 */         this.data = baos.getBuffer();
/* 156 */         this.dataLen = baos.size();
/*     */       }
/*     */       catch (IOException e) {
/* 159 */         this.dataLen = 0;
/*     */       }
/*     */     }
/* 162 */     return this.data;
/*     */   }
/*     */   
/*     */   public int getDataLen() {
/* 166 */     return this.dataLen;
/*     */   }
/*     */   
/*     */   public String getMimeType() {
/* 170 */     if (this.mimeType == null)
/* 171 */       return "application/octet-stream";
/* 172 */     return this.mimeType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int length()
/*     */   {
/* 182 */     get();
/* 183 */     return (this.dataLen + 2) / 3 * 4;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public char charAt(int index)
/*     */   {
/* 195 */     int offset = index % 4;
/* 196 */     int base = index / 4 * 3;
/*     */     
/*     */     byte b1;
/*     */     
/* 200 */     switch (offset) {
/*     */     case 0: 
/* 202 */       return DatatypeConverterImpl.encode(this.data[base] >> 2);
/*     */     case 1:  byte b1;
/* 204 */       if (base + 1 < this.dataLen) {
/* 205 */         b1 = this.data[(base + 1)];
/*     */       } else
/* 207 */         b1 = 0;
/* 208 */       return DatatypeConverterImpl.encode((this.data[base] & 0x3) << 4 | b1 >> 4 & 0xF);
/*     */     
/*     */ 
/*     */     case 2: 
/* 212 */       if (base + 1 < this.dataLen) {
/* 213 */         b1 = this.data[(base + 1)];
/* 214 */         byte b2; byte b2; if (base + 2 < this.dataLen) {
/* 215 */           b2 = this.data[(base + 2)];
/*     */         } else {
/* 217 */           b2 = 0;
/*     */         }
/* 219 */         return DatatypeConverterImpl.encode((b1 & 0xF) << 2 | b2 >> 6 & 0x3);
/*     */       }
/*     */       
/*     */ 
/* 223 */       return '=';
/*     */     case 3: 
/* 225 */       if (base + 2 < this.dataLen) {
/* 226 */         return DatatypeConverterImpl.encode(this.data[(base + 2)] & 0x3F);
/*     */       }
/* 228 */       return '=';
/*     */     }
/*     */     
/* 231 */     throw new IllegalStateException();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public CharSequence subSequence(int start, int end)
/*     */   {
/* 240 */     StringBuilder buf = new StringBuilder();
/* 241 */     get();
/* 242 */     for (int i = start; i < end; i++)
/* 243 */       buf.append(charAt(i));
/* 244 */     return buf;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 251 */     get();
/* 252 */     return DatatypeConverterImpl._printBase64Binary(this.data, 0, this.dataLen);
/*     */   }
/*     */   
/*     */   public void writeTo(char[] buf, int start) {
/* 256 */     get();
/* 257 */     DatatypeConverterImpl._printBase64Binary(this.data, 0, this.dataLen, buf, start);
/*     */   }
/*     */   
/*     */   public void writeTo(UTF8XmlOutput output) throws IOException
/*     */   {
/* 262 */     get();
/* 263 */     output.text(this.data, this.dataLen);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\Base64Data.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */