/*     */ package com.sun.xml.txw2.output;
/*     */ 
/*     */ import com.sun.xml.txw2.TxwException;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Stack;
/*     */ import javax.xml.parsers.DocumentBuilder;
/*     */ import javax.xml.parsers.DocumentBuilderFactory;
/*     */ import javax.xml.parsers.ParserConfigurationException;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.Locator;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.ext.LexicalHandler;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class Dom2SaxAdapter
/*     */   implements ContentHandler, LexicalHandler
/*     */ {
/*     */   private final Node _node;
/* 113 */   private final Stack _nodeStk = new Stack();
/*     */   private boolean inCDATA;
/*     */   private final Document _document;
/*     */   
/* 117 */   public final Element getCurrentElement() { return (Element)this._nodeStk.peek(); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Dom2SaxAdapter(Node node)
/*     */   {
/* 131 */     this._node = node;
/* 132 */     this._nodeStk.push(this._node);
/*     */     
/* 134 */     if ((node instanceof Document)) {
/* 135 */       this._document = ((Document)node);
/*     */     } else {
/* 137 */       this._document = node.getOwnerDocument();
/*     */     }
/*     */   }
/*     */   
/*     */   public Dom2SaxAdapter()
/*     */     throws ParserConfigurationException
/*     */   {
/* 144 */     DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
/* 145 */     factory.setNamespaceAware(true);
/* 146 */     factory.setValidating(false);
/*     */     
/* 148 */     this._document = factory.newDocumentBuilder().newDocument();
/* 149 */     this._node = this._document;
/* 150 */     this._nodeStk.push(this._document);
/*     */   }
/*     */   
/*     */   public Node getDOM() {
/* 154 */     return this._node;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void startDocument() {}
/*     */   
/*     */ 
/*     */   public void endDocument() {}
/*     */   
/*     */ 
/*     */   public void startElement(String namespace, String localName, String qName, Attributes attrs)
/*     */   {
/* 167 */     Element element = this._document.createElementNS(namespace, qName);
/*     */     
/* 169 */     if (element == null)
/*     */     {
/*     */ 
/* 172 */       throw new TxwException("Your DOM provider doesn't support the createElementNS method properly");
/*     */     }
/*     */     
/*     */ 
/* 176 */     for (int i = 0; i < this.unprocessedNamespaces.size(); i += 2) {
/* 177 */       String prefix = (String)this.unprocessedNamespaces.get(i + 0);
/* 178 */       String uri = (String)this.unprocessedNamespaces.get(i + 1);
/*     */       String qname;
/*     */       String qname;
/* 181 */       if (("".equals(prefix)) || (prefix == null)) {
/* 182 */         qname = "xmlns";
/*     */       } else {
/* 184 */         qname = "xmlns:" + prefix;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 189 */       if (element.hasAttributeNS("http://www.w3.org/2000/xmlns/", qname))
/*     */       {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 197 */         element.removeAttributeNS("http://www.w3.org/2000/xmlns/", qname);
/*     */       }
/*     */       
/*     */ 
/* 201 */       element.setAttributeNS("http://www.w3.org/2000/xmlns/", qname, uri);
/*     */     }
/* 203 */     this.unprocessedNamespaces.clear();
/*     */     
/*     */ 
/* 206 */     int length = attrs.getLength();
/* 207 */     for (int i = 0; i < length; i++) {
/* 208 */       String namespaceuri = attrs.getURI(i);
/* 209 */       String value = attrs.getValue(i);
/* 210 */       String qname = attrs.getQName(i);
/* 211 */       element.setAttributeNS(namespaceuri, qname, value);
/*     */     }
/*     */     
/* 214 */     getParent().appendChild(element);
/*     */     
/* 216 */     this._nodeStk.push(element);
/*     */   }
/*     */   
/*     */   private final Node getParent() {
/* 220 */     return (Node)this._nodeStk.peek();
/*     */   }
/*     */   
/*     */   public void endElement(String namespace, String localName, String qName) {
/* 224 */     this._nodeStk.pop();
/*     */   }
/*     */   
/*     */   public void characters(char[] ch, int start, int length) {
/*     */     Node text;
/*     */     Node text;
/* 230 */     if (this.inCDATA) {
/* 231 */       text = this._document.createCDATASection(new String(ch, start, length));
/*     */     } else
/* 233 */       text = this._document.createTextNode(new String(ch, start, length));
/* 234 */     getParent().appendChild(text);
/*     */   }
/*     */   
/*     */   public void comment(char[] ch, int start, int length) throws SAXException {
/* 238 */     getParent().appendChild(this._document.createComment(new String(ch, start, length)));
/*     */   }
/*     */   
/*     */ 
/*     */   public void ignorableWhitespace(char[] ch, int start, int length) {}
/*     */   
/*     */   public void processingInstruction(String target, String data)
/*     */     throws SAXException
/*     */   {
/* 247 */     Node node = this._document.createProcessingInstruction(target, data);
/* 248 */     getParent().appendChild(node);
/*     */   }
/*     */   
/*     */ 
/*     */   public void setDocumentLocator(Locator locator) {}
/*     */   
/*     */ 
/*     */   public void skippedEntity(String name) {}
/*     */   
/* 257 */   private ArrayList unprocessedNamespaces = new ArrayList();
/*     */   
/*     */   public void startPrefixMapping(String prefix, String uri) {
/* 260 */     this.unprocessedNamespaces.add(prefix);
/* 261 */     this.unprocessedNamespaces.add(uri);
/*     */   }
/*     */   
/*     */   public void endPrefixMapping(String prefix) {}
/*     */   
/*     */   public void startDTD(String name, String publicId, String systemId) throws SAXException
/*     */   {}
/*     */   
/*     */   public void endDTD() throws SAXException
/*     */   {}
/*     */   
/*     */   public void startEntity(String name) throws SAXException
/*     */   {}
/*     */   
/*     */   public void endEntity(String name) throws SAXException
/*     */   {}
/*     */   
/*     */   public void startCDATA() throws SAXException
/*     */   {
/* 280 */     this.inCDATA = true;
/*     */   }
/*     */   
/*     */   public void endCDATA() throws SAXException {
/* 284 */     this.inCDATA = false;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\output\Dom2SaxAdapter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */