/*     */ package com.thoughtworks.paranamer;
/*     */ 
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.lang.reflect.AccessibleObject;
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.lang.reflect.Method;
/*     */ import javax.inject.Named;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AnnotationParanamer
/*     */   implements Paranamer
/*     */ {
/*     */   public static final String __PARANAMER_DATA = "v1.0 \nlookupParameterNames java.lang.AccessibleObject methodOrConstructor \nlookupParameterNames java.lang.AccessibleObject,boolean methodOrCtor,throwExceptionIfMissing \n";
/*     */   private final Paranamer fallback;
/*     */   
/*     */   public AnnotationParanamer()
/*     */   {
/*  55 */     this(new NullParanamer());
/*     */   }
/*     */   
/*     */   public AnnotationParanamer(Paranamer fallback) {
/*  59 */     this.fallback = fallback;
/*     */   }
/*     */   
/*     */   public String[] lookupParameterNames(AccessibleObject methodOrConstructor) {
/*  63 */     return lookupParameterNames(methodOrConstructor, true);
/*     */   }
/*     */   
/*     */   public String[] lookupParameterNames(AccessibleObject methodOrCtor, boolean throwExceptionIfMissing)
/*     */   {
/*  68 */     Class<?>[] types = null;
/*  69 */     Class<?> declaringClass = null;
/*  70 */     String name = null;
/*  71 */     Annotation[][] anns = (Annotation[][])null;
/*  72 */     if ((methodOrCtor instanceof Method)) {
/*  73 */       Method method = (Method)methodOrCtor;
/*  74 */       types = method.getParameterTypes();
/*  75 */       name = method.getName();
/*  76 */       declaringClass = method.getDeclaringClass();
/*  77 */       anns = method.getParameterAnnotations();
/*     */     } else {
/*  79 */       Constructor<?> constructor = (Constructor)methodOrCtor;
/*  80 */       types = constructor.getParameterTypes();
/*  81 */       declaringClass = constructor.getDeclaringClass();
/*  82 */       name = "<init>";
/*  83 */       anns = constructor.getParameterAnnotations();
/*     */     }
/*     */     
/*  86 */     if (types.length == 0) {
/*  87 */       return EMPTY_NAMES;
/*     */     }
/*     */     
/*     */ 
/*  91 */     String[] names = new String[types.length];
/*  92 */     boolean allDone = true;
/*  93 */     for (int i = 0; i < names.length; i++) {
/*  94 */       for (int j = 0; j < anns[i].length; j++) {
/*  95 */         Annotation ann = anns[i][j];
/*  96 */         if (isNamed(ann)) {
/*  97 */           names[i] = getNamedValue(ann);
/*  98 */           break;
/*     */         }
/*     */       }
/* 101 */       if (names[i] == null) {
/* 102 */         allDone = false;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 108 */     if (!allDone) {
/* 109 */       allDone = true;
/* 110 */       String[] altNames = this.fallback.lookupParameterNames(methodOrCtor, false);
/* 111 */       if (altNames.length > 0) {
/* 112 */         for (int i = 0; i < names.length; i++) {
/* 113 */           if (names[i] == null) {
/* 114 */             if (altNames[i] != null) {
/* 115 */               names[i] = altNames[i];
/*     */             } else {
/* 117 */               allDone = false;
/*     */             }
/*     */           }
/*     */         }
/*     */       } else {
/* 122 */         allDone = false;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 127 */     if (!allDone) {
/* 128 */       if (throwExceptionIfMissing) {
/* 129 */         throw new ParameterNamesNotFoundException("One or more @Named annotations missing for class '" + declaringClass.getName() + "', methodOrCtor " + name + " and parameter types " + DefaultParanamer.getParameterTypeNamesCSV(types));
/*     */       }
/*     */       
/* 132 */       return Paranamer.EMPTY_NAMES;
/*     */     }
/*     */     
/* 135 */     return names;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected String getNamedValue(Annotation ann)
/*     */   {
/* 147 */     if ("javax.inject.Named".equals(ann.annotationType().getName())) {
/* 148 */       return Jsr330Helper.getNamedValue(ann);
/*     */     }
/* 150 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected boolean isNamed(Annotation ann)
/*     */   {
/* 164 */     if ("javax.inject.Named".equals(ann.annotationType().getName())) {
/* 165 */       return Jsr330Helper.isNamed(ann);
/*     */     }
/* 167 */     return false;
/*     */   }
/*     */   
/*     */   public static class Jsr330Helper
/*     */   {
/*     */     public static final String __PARANAMER_DATA = "";
/*     */     
/*     */     private static boolean isNamed(Annotation ann)
/*     */     {
/* 176 */       return ann instanceof Named;
/*     */     }
/*     */     
/* 179 */     private static String getNamedValue(Annotation ann) { return ((Named)ann).value(); }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\thoughtworks\paranamer\AnnotationParanamer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */