/*     */ package net.rubyeye.xmemcached.command.binary;
/*     */ 
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.List;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.AssocCommandAware;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.transcoders.CachedData;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BinaryGetCommand
/*     */   extends BaseBinaryCommand
/*     */   implements AssocCommandAware
/*     */ {
/*     */   private String responseKey;
/*     */   private CachedData responseValue;
/*     */   private List<Command> assocCommands;
/*     */   
/*     */   public final String getResponseKey()
/*     */   {
/*  48 */     return this.responseKey;
/*     */   }
/*     */   
/*     */   public final void setResponseKey(String responseKey) {
/*  52 */     this.responseKey = responseKey;
/*     */   }
/*     */   
/*     */   public BinaryGetCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, OpCode opCode, boolean noreply)
/*     */   {
/*  57 */     super(key, keyBytes, cmdType, latch, 0, 0L, null, noreply, null);
/*  58 */     this.opCode = opCode;
/*  59 */     this.responseValue = new CachedData();
/*     */   }
/*     */   
/*     */   public final List<Command> getAssocCommands() {
/*  63 */     return this.assocCommands;
/*     */   }
/*     */   
/*     */   public final void setAssocCommands(List<Command> assocCommands) {
/*  67 */     this.assocCommands = assocCommands;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void readHeader(ByteBuffer buffer)
/*     */   {
/*  75 */     super.readHeader(buffer);
/*  76 */     if ((this.responseStatus != ResponseStatus.NO_ERROR) && 
/*  77 */       (ByteUtils.stepBuffer(buffer, this.responseTotalBodyLength))) {
/*  78 */       this.decodeStatus = BinaryDecodeStatus.DONE;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected boolean finish()
/*     */   {
/*  86 */     countDownLatch();
/*  87 */     return true;
/*     */   }
/*     */   
/*     */   protected boolean readKey(ByteBuffer buffer, int keyLength)
/*     */   {
/*  92 */     if (buffer.remaining() < keyLength) {
/*  93 */       return false;
/*     */     }
/*  95 */     if (keyLength > 0) {
/*  96 */       byte[] bytes = new byte[keyLength];
/*  97 */       buffer.get(bytes);
/*  98 */       this.responseKey = ByteUtils.getString(bytes);
/*     */     }
/* 100 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */   protected boolean readValue(ByteBuffer buffer, int bodyLength, int keyLength, int extrasLength)
/*     */   {
/* 106 */     if (this.responseStatus == ResponseStatus.NO_ERROR) {
/* 107 */       int valueLength = bodyLength - keyLength - extrasLength;
/* 108 */       if ((valueLength >= 0) && (this.responseValue.getCapacity() < 0)) {
/* 109 */         this.responseValue.setCapacity(valueLength);
/* 110 */         this.responseValue.setData(new byte[valueLength]);
/*     */       }
/* 112 */       int remainingCapacity = this.responseValue.remainingCapacity();
/* 113 */       int remaining = buffer.remaining();
/* 114 */       if (remaining < remainingCapacity) {
/* 115 */         int length = remaining > remainingCapacity ? remainingCapacity : remaining;
/*     */         
/* 117 */         this.responseValue.fillData(buffer, length);
/* 118 */         return false; }
/* 119 */       if (remainingCapacity > 0) {
/* 120 */         this.responseValue.fillData(buffer, remainingCapacity);
/*     */       }
/* 122 */       setResult(this.responseValue);
/* 123 */       return true;
/*     */     }
/* 125 */     return ByteUtils.stepBuffer(buffer, bodyLength - keyLength - extrasLength);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected boolean readExtras(ByteBuffer buffer, int extrasLength)
/*     */   {
/* 132 */     if (buffer.remaining() < extrasLength) {
/* 133 */       return false;
/*     */     }
/* 135 */     if (extrasLength > 0)
/*     */     {
/* 137 */       int flag = buffer.getInt();
/* 138 */       this.responseValue.setFlag(flag);
/*     */     }
/* 140 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected void fillExtras(CachedData data) {}
/*     */   
/*     */ 
/*     */ 
/*     */   protected void fillValue(CachedData data) {}
/*     */   
/*     */ 
/*     */ 
/*     */   protected byte getExtrasLength()
/*     */   {
/* 155 */     return 0;
/*     */   }
/*     */   
/*     */   protected int getValueLength(CachedData data)
/*     */   {
/* 160 */     return 0;
/*     */   }
/*     */   
/*     */   protected long readCAS(ByteBuffer buffer)
/*     */   {
/* 165 */     long cas = buffer.getLong();
/* 166 */     this.responseValue.setCas(cas);
/* 167 */     return cas;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\binary\BinaryGetCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */