/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.support.builder;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientFile;
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientReferenceableFile;
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientSecureMondrianConnection;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.support.decorator.SecureMondrianConnectionResourceOperationProcessorDecorator;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.sun.jersey.multipart.FormDataMultiPart;
/*    */ import java.io.InputStream;
/*    */ import java.util.List;
/*    */ import javax.ws.rs.core.MediaType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SecureMondrianConnectionResourceBuilder
/*    */   extends SecureMondrianConnectionResourceOperationProcessorDecorator
/*    */ {
/* 38 */   private int schemaCounter = 0;
/*    */   
/*    */   public SecureMondrianConnectionResourceBuilder(ClientSecureMondrianConnection entity, SessionStorage storage) {
/* 41 */     super(storage, entity);
/*    */   }
/*    */   
/*    */   public SecureMondrianConnectionResourceBuilder withMondrianSchema(InputStream schema, ClientFile schemaDescriptor) {
/* 45 */     this.multipart.field("schema", schema, new MediaType("application", "olapMondrianSchema+xml"));
/* 46 */     this.connection.setSchema(schemaDescriptor);
/* 47 */     return this;
/*    */   }
/*    */   
/*    */   public SecureMondrianConnectionResourceBuilder withMondrianSchema(String schema, ClientFile schemaDescriptor) {
/* 51 */     this.multipart.field("schema", schema, new MediaType("application", "olapMondrianSchema+xml"));
/* 52 */     this.connection.setSchema(schemaDescriptor);
/* 53 */     return this;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public SecureMondrianConnectionResourceBuilder withAccessGrantSchemasAsStream(List<InputStream> schemas, List<ClientReferenceableFile> schemaDescriptors)
/*    */   {
/* 67 */     this.connection.setAccessGrants(schemaDescriptors);
/* 68 */     for (InputStream schema : schemas) {
/* 69 */       this.multipart.field("accessGrantSchemas.accessGrantSchema[" + this.schemaCounter + "]", schema, new MediaType("application", "accessGrantSchema+xml"));
/*    */     }
/* 71 */     return this;
/*    */   }
/*    */   
/*    */   public SecureMondrianConnectionResourceBuilder withAccessGrantSchemasAsString(List<String> schemas, List<ClientReferenceableFile> schemaDescriptors) {
/* 75 */     this.connection.setAccessGrants(schemaDescriptors);
/* 76 */     for (String schema : schemas) {
/* 77 */       this.multipart.field("accessGrantSchemas.accessGrantSchema[" + this.schemaCounter + "]", schema, new MediaType("application", "accessGrantSchema+xml"));
/*    */     }
/* 79 */     return this;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public SecureMondrianConnectionResourceBuilder withUri(String uri)
/*    */   {
/* 97 */     this.connection.setUri(uri);
/* 98 */     return this;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\resources\support\builder\SecureMondrianConnectionResourceBuilder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */