/*    */ package com.netapp.asup.cache.server;
/*    */ 
/*    */ import com.netapp.asup.cache.LRU.AsupLRUCacheStats;
/*    */ import com.netapp.asup.util.CacheUtils;
/*    */ import java.util.concurrent.atomic.AtomicLong;
/*    */ 
/*    */ public class AsupMemCacheStats
/*    */   extends AsupLRUCacheStats
/*    */ {
/* 10 */   private final AtomicLong clearCount = new AtomicLong(0L);
/*    */   
/* 12 */   private final AtomicLong bulkGetCount = new AtomicLong(0L);
/*    */   
/* 14 */   private final AtomicLong replaceCount = new AtomicLong(0L);
/*    */   
/*    */   public void clear() {
/* 17 */     this.clearCount.incrementAndGet();
/*    */   }
/*    */   
/*    */   public void replace() {
/* 21 */     this.replaceCount.incrementAndGet();
/*    */   }
/*    */   
/*    */   public long getReplaceCount() {
/* 25 */     return this.replaceCount.get();
/*    */   }
/*    */   
/*    */   public void bulkGet() {
/* 29 */     this.bulkGetCount.incrementAndGet();
/*    */   }
/*    */   
/*    */   public long getBulkCount() {
/* 33 */     return this.bulkGetCount.get();
/*    */   }
/*    */   
/*    */   public long getClearCount() {
/* 37 */     return this.clearCount.get();
/*    */   }
/*    */   
/*    */   public long getAccessCount()
/*    */   {
/* 42 */     return getRequestCount() + getRemovedCount() + getReplaceCount() + getBulkCount() + getClearCount() + this.accessCount.get();
/*    */   }
/*    */   
/*    */ 
/*    */   public String getMissRatio()
/*    */   {
/* 48 */     double missRatio = (float)getMissCount() / (float)getRequestCount();
/* 49 */     if (getMissCount() == 0L) return "0"; return CacheUtils.formatPercent(missRatio, 2);
/*    */   }
/*    */   
/*    */ 
/*    */   public String toString()
/*    */   {
/* 55 */     return "ARMAMemCacheStats [ hitCount=" + this.hitCount.get() + ", missCount=" + this.missCount.get() + ", accessCount=" + getAccessCount() + ", removedCount=" + this.removedCount.get() + " clearCount=" + this.clearCount.get() + ", bulkGetCount=" + this.bulkGetCount.get() + ", replaceCount=" + this.replaceCount.get() + ", missRatio=" + getMissRatio() + ",hitRatio=" + getHitRatio() + "]";
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\cache\server\AsupMemCacheStats.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */