/*    */ package com.netapp.asup.data.function.sort;
/*    */ 
/*    */ import com.netapp.asup.data.function.FunctionInputHandler;
/*    */ import java.util.HashMap;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Field;
/*    */ import org.apache.avro.generic.GenericData.Array;
/*    */ import org.apache.avro.generic.GenericData.Record;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SortInputHandler
/*    */   implements FunctionInputHandler<SortInputImpl>
/*    */ {
/*    */   private static final String SORT_INPUT = "sortInput";
/*    */   
/*    */   public GenericRecord handleInput(Schema schema, SortInputImpl input)
/*    */   {
/* 30 */     Schema fieldsArraySchema = schema.getField("sortInput").schema().getValueType();
/*    */     
/* 32 */     Schema fieldRecordSchema = fieldsArraySchema.getElementType();
/* 33 */     GenericRecord record = new GenericData.Record(schema);
/*    */     
/* 35 */     Map<String, List<SortInputImpl.SortField>> sortInputObjects = input.getSortInput();
/*    */     
/* 37 */     Map<Utf8, GenericData.Array<GenericRecord>> output = new HashMap();
/* 38 */     List<SortInputImpl.SortField> fields = null;
/* 39 */     GenericData.Array<GenericRecord> attrOutput = null;
/*    */     
/* 41 */     for (String path : sortInputObjects.keySet()) {
/* 42 */       fields = (List)sortInputObjects.get(path);
/* 43 */       attrOutput = new GenericData.Array(fields.size(), fieldsArraySchema);
/*    */       
/* 45 */       for (SortInputImpl.SortField sortField : fields) {
/* 46 */         attrOutput.add(sortField.getObject(fieldRecordSchema));
/*    */       }
/* 48 */       output.put(new Utf8(path), attrOutput);
/*    */     }
/* 50 */     record.put("sortInput", output);
/* 51 */     return record;
/*    */   }
/*    */   
/*    */   public SortInputImpl handleInput(GenericRecord record)
/*    */   {
/* 56 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\sort\SortInputHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */