/*    */ package com.netapp.asup.metamodel;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.exception.ARMAConfigurationException;
/*    */ import com.netapp.asup.exception.ARMAMetaModelException;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ import java.util.Properties;
/*    */ import prefuse.data.Graph;
/*    */ import prefuse.data.io.DataIOException;
/*    */ import prefuse.data.io.GraphMLReader;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class FileConnector
/*    */   implements Connector
/*    */ {
/* 23 */   private static final AsupLogger LOGGER = AsupLogger.getLogger(FileConnector.class);
/*    */   
/*    */ 
/* 26 */   private final Properties prop = new Properties();
/*    */   
/*    */   public FileConnector(String graphMLMappings) throws ARMAConfigurationException {
/*    */     try {
/* 30 */       this.prop.load(getClass().getClassLoader().getResourceAsStream(graphMLMappings));
/*    */     }
/*    */     catch (IOException e) {
/* 33 */       throw new ARMAConfigurationException(LOGGER, "Filure to load the properties file :" + graphMLMappings, e);
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */   public Graph getMetaModel(String versionName)
/*    */     throws ARMAMetaModelException
/*    */   {
/* 41 */     InputStream isGraphMl = null;
/*    */     try {
/* 43 */       isGraphMl = getMetaModelStream(versionName);
/* 44 */       GraphMLReader reader = new GraphMLReader();
/*    */       Graph graph;
/*    */       try {
/* 47 */         graph = reader.readGraph(isGraphMl);
/*    */       } catch (DataIOException e) {
/* 49 */         throw new ARMAMetaModelException(LOGGER, versionName, "Unable to read graph data caused by: " + e.getMessage(), e);
/*    */       }
/*    */       
/* 52 */       return graph;
/*    */     } finally {
/* 54 */       if (isGraphMl != null) {
/*    */         try {
/* 56 */           isGraphMl.close();
/*    */         } catch (IOException e) {
/* 58 */           throw new ARMAMetaModelException(LOGGER, versionName, "Unable to close inputStream caused by :" + e.getMessage(), e);
/*    */         }
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */   public InputStream getMetaModelStream(String versionName) throws ARMAMetaModelException {
/* 65 */     LOGGER.debug("-9999", "Version name requested for : " + versionName);
/*    */     
/* 67 */     String graphName = this.prop.getProperty(versionName);
/* 68 */     InputStream isGraphMl = null;
/* 69 */     if (graphName != null) {
/* 70 */       isGraphMl = getClass().getClassLoader().getResourceAsStream(graphName);
/*    */       
/* 72 */       return isGraphMl;
/*    */     }
/* 74 */     throw new ARMAMetaModelException(LOGGER, versionName, "No graph exist against the specified version");
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\metamodel\FileConnector.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */