/*     */ package org.apache.avro.io;
/*     */ 
/*     */ import java.io.Flushable;
/*     */ import java.io.IOException;
/*     */ import java.nio.ByteBuffer;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Encoder
/*     */   implements Flushable
/*     */ {
/*     */   public abstract void writeNull()
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeBoolean(boolean paramBoolean)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeInt(int paramInt)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeLong(long paramLong)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeFloat(float paramFloat)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeDouble(double paramDouble)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeString(Utf8 paramUtf8)
/*     */     throws IOException;
/*     */   
/*     */   public void writeString(String str)
/*     */     throws IOException
/*     */   {
/* 107 */     writeString(new Utf8(str));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void writeString(CharSequence charSequence)
/*     */     throws IOException
/*     */   {
/* 118 */     if ((charSequence instanceof Utf8)) {
/* 119 */       writeString((Utf8)charSequence);
/*     */     } else {
/* 121 */       writeString(charSequence.toString());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void writeBytes(ByteBuffer paramByteBuffer)
/*     */     throws IOException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void writeBytes(byte[] paramArrayOfByte, int paramInt1, int paramInt2)
/*     */     throws IOException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void writeBytes(byte[] bytes)
/*     */     throws IOException
/*     */   {
/* 146 */     writeBytes(bytes, 0, bytes.length);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void writeFixed(byte[] paramArrayOfByte, int paramInt1, int paramInt2)
/*     */     throws IOException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void writeFixed(byte[] bytes)
/*     */     throws IOException
/*     */   {
/* 166 */     writeFixed(bytes, 0, bytes.length);
/*     */   }
/*     */   
/*     */   public void writeFixed(ByteBuffer bytes) throws IOException
/*     */   {
/* 171 */     int pos = bytes.position();
/* 172 */     int len = bytes.limit() - pos;
/* 173 */     if (bytes.hasArray()) {
/* 174 */       writeFixed(bytes.array(), bytes.arrayOffset() + pos, len);
/*     */     } else {
/* 176 */       byte[] b = new byte[len];
/* 177 */       bytes.get(b, 0, len);
/* 178 */       writeFixed(b, 0, len);
/*     */     }
/*     */   }
/*     */   
/*     */   public abstract void writeEnum(int paramInt)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeArrayStart()
/*     */     throws IOException;
/*     */   
/*     */   public abstract void setItemCount(long paramLong)
/*     */     throws IOException;
/*     */   
/*     */   public abstract void startItem()
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeArrayEnd()
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeMapStart()
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeMapEnd()
/*     */     throws IOException;
/*     */   
/*     */   public abstract void writeIndex(int paramInt)
/*     */     throws IOException;
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\Encoder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */