/*    */ package org.codehaus.janino.util.resource;
/*    */ 
/*    */ import java.io.File;
/*    */ import java.io.FilenameFilter;
/*    */ import java.io.IOException;
/*    */ import java.util.Arrays;
/*    */ import java.util.Collections;
/*    */ import java.util.Iterator;
/*    */ import java.util.List;
/*    */ import java.util.zip.ZipFile;
/*    */ import org.codehaus.janino.util.iterator.MultiDimensionalIterator;
/*    */ import org.codehaus.janino.util.iterator.TransformingIterator;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class JarDirectoriesResourceFinder
/*    */   extends LazyMultiResourceFinder
/*    */ {
/*    */   public JarDirectoriesResourceFinder(File[] directories)
/*    */   {
/* 44 */     super(new MultiDimensionalIterator(new TransformingIterator(Arrays.asList(directories).iterator())
/*    */     {
/*    */ 
/*    */       protected Object transform(Object o)
/*    */       {
/* 49 */         File directory = (File)o;
/*    */         
/* 51 */         if (!directory.exists()) { return Collections.EMPTY_LIST.iterator();
/*    */         }
/*    */         
/* 54 */         File[] jarFiles = directory.listFiles(new FilenameFilter() {
/* 55 */           public boolean accept(File dir, String name) { return name.endsWith(".jar"); }
/* 56 */         });
/* 57 */         new TransformingIterator(Arrays.asList(jarFiles).iterator()) {
/*    */           protected Object transform(Object o) {
/* 59 */             File zipFile = (File)o;
/*    */             try {
/* 61 */               return new ZipFileResourceFinder(new ZipFile(zipFile));
/*    */             } catch (IOException e) {}
/* 63 */             return ResourceFinder.EMPTY_RESOURCE_FINDER;
/*    */           }
/*    */         };
/*    */       }
/* 57 */     }, 2));
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\resource\JarDirectoriesResourceFinder.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */