package prefuse.data.util;

import prefuse.data.event.ProjectionListener;
import prefuse.util.collections.CopyOnWriteArrayList;

public abstract class AbstractColumnProjection
  implements ColumnProjection
{
  private CopyOnWriteArrayList m_listeners;
  
  public void addProjectionListener(ProjectionListener paramProjectionListener)
  {
    if (this.m_listeners == null) {
      this.m_listeners = new CopyOnWriteArrayList();
    }
    if (!this.m_listeners.contains(paramProjectionListener)) {
      this.m_listeners.add(paramProjectionListener);
    }
  }
  
  public void removeProjectionListener(ProjectionListener paramProjectionListener)
  {
    if (this.m_listeners != null) {
      this.m_listeners.remove(paramProjectionListener);
    }
    if (this.m_listeners.size() == 0) {
      this.m_listeners = null;
    }
  }
  
  public void fireUpdate()
  {
    if (this.m_listeners == null) {
      return;
    }
    Object[] arrayOfObject = this.m_listeners.getArray();
    for (int i = 0; i < arrayOfObject.length; i++) {
      ((ProjectionListener)arrayOfObject[i]).projectionChanged(this);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\util\AbstractColumnProjection.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */